unit MainHelpGen;

interface

uses windows, messages, kol, ShellAPI, PascalUnit;

type
  PEventObj = ^TEventObj;
  TEventObj = object( TObj )
  private
    FTime : TSystemTime;
    FTimer : PTimer;
    procedure TimerTick( Sender : PObj );
    procedure BuildHelp( Sender : PObj );
    procedure CancelBuild( Sender : PObj );
  protected
  public
    destructor Destroy; virtual;
  end;

var Bevel1, Progress1, Button1, Label1 : PControl;
    EventObj: PEventObj;

function NewForm1( AParent: PControl ): PControl;

type
  TTopicType = ( ttUnit, ttClass, ttRecord, ttType, ttConst,
                 ttMethod, ttField, ttProperty );
  TTriplean = ( Unknown, Yes, No );
  PTopic = ^TTopic;
  TTopic = object( TObj )
  private
    FName : String;
    FType : TTopicType;
    FDefinition : String;
    FDescription : PStrList;
    FDescrText : PStrList;
    FRecDef : PStrList;
    FRecCln : PStrList;
    FProtected : Boolean;
    FReadOnly : TTriplean;
    FUses : PStrList;
    FHandled : Boolean;
    FNode : PTree;
    FAncestor: String;
    FTasks: PStrList;
    FPrev, FNext : PTopic;
    FMacroList : PStrList;
    FSigh : Boolean;
    FIsChanged : Boolean;
    FTopics: PList;
    FParentTopic: PTopic;
    function GetHtName: String;
    function GetReadOnly: TTriplean;
    function GetChanged: Boolean;
    function GetChildTopic(Idx: Integer): PTopic;
    function GetChildTopicCount: Integer;
  protected
  public
    destructor Destroy; virtual;
    Property Name : String read FName;
    Property TopicType : TTopicType read FType;
    Property Definition : String read FDefinition;
    Property Description : PStrList read FDescription;
    Property DescrText : PStrList read FDescrText write FDescrText;
    property IsProtected : Boolean read FProtected write FProtected;
    property IsReadOnly : TTriplean read GetReadOnly write FReadOnly;
    property HtName : String read GetHtName;
    property Ancestor : String read FAncestor write FAncestor;
    property Tasks : PStrList read FTasks;
    property IsChanged : Boolean read GetChanged;
    property Topics[ Idx: Integer ]: PTopic read GetChildTopic;
    property TopicsCount: Integer read GetChildTopicCount;
    property ParentTopic: PTopic read FParentTopic;
  end;

  function NewTopic( AParent: PTopic; TopicType: TTopicType;
           const TopicName, Definition: String; Description: PStrList ): PTopic;

type
  PGlossElt = ^TGlossElt;
  TGlossElt = object( TObj )
  private
  protected
  public
    Name : String;
    Text : String;
    InUnit: PTopic;
    InClass: PTopic;
    RefTopic: PTopic;
    destructor Destroy; virtual;
  end;

function NewGlossElt: PGlossElt;

var
  Months: array[ 1..12 ] of String = ( 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
                                       'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec' );
  {BgColor: String = '424242';
  TxColor: String = 'FFFFFF';
  HdColor: String = 'FF8080';
  CLink: String = '00FF80';
  ALink: String = '80FF00';
  VLink: String = '00FF00';
  ColorClass: String = 'FFFF00';
  ColorReserved: String = '40C0FF';
  ColorName: String = '00FFFF';
  ColorOther: String = '00FFFF';
  ColorString: String = 'E0E000';
  ColorComment: String = '40FF40';}

  BgColor: String = 'FFFFEF';
  TxColor: String = '000000';
  HdColor: String = 'FF8080';
  CLink: String = '008080';
  ALink: String = '808000';
  VLink: String = '008000';
  ColorClass: String = '808000';
  ColorReserved: String = '800000';
  ColorName: String = '800080';
  ColorOther: String = '008080';
  ColorString: String = 'A08020';
  ColorComment: String = '40A040';

var Form1 : PControl;
    SourcePath : String;
    ResultPath : String;
    LaguageID : String;
    UnitsList : PList;
    CurrentUnit : PTopic;
    CurrentClass: PTopic;
    CurrentTopic: PTopic;
    UseJavaScript: Boolean;
    Cancel : Boolean;
    Glossary : PList;
    MacroList: PStrList;
    GeneratingUnit, GeneratingSample : Boolean;
    CustomRefs: PList;
var DynamicTree : Boolean = True;
    Param, ExePath : String;
    ClassList : PList;
    LookSubfolders: Boolean;
    FileList: PStrList;
    TitleString: String = 'KOL Help';
    IniDirPath: String;
    Special: Char = '*';
    UseWebdings: Boolean = True;
{*BAP}
   ParentHelp: Boolean;
const
  cVK_BAP = ' by KOL Help generator, (C) 2000-2001 by Vladimir Kladov<br>' +
    'Modified (C) 2003 by Alexander Bartov</small></font></p>';
{*BAP}   

procedure GenerateXclHelp;

procedure RunXCLHelp;

implementation

function UnitPath( I: Integer ): String;
begin
  Result := CopyEnd( FileList.Items[ I ], 2 );
  Result := Parse( Result, ',' );
end;

function NewGlossElt: PGlossElt;
begin
  New( Result, Create );
end;

function NewForm1( AParent: PControl ): PControl;
begin
  New( EventObj, Create );

  Result := NewForm( AParent, 'Generating help' );

  Progress1 := NewProgressbar( Result ).SetSize( 280, 20 ).ResizeParentRight;
  Button1 := NewButton( Result, 'Start' ).SetSize( 62, 0 ).PlaceDown.ResizeParentBottom;
  Button1.OnClick := EventObj.BuildHelp;
  Label1 := NewLabel( Result, '' ).PlaceRight.SetSize( 220, 0 );
  GetLocalTime( EventObj.FTime );
  Result.Left := (GetSystemMetrics( SM_CXSCREEN ) - Result.Width) div 2;
  Result.Top := (GetSystemMetrics( SM_CYSCREEN ) - Result.Height) div 2;

  EventObj.FTimer := NewTimer( 100 );
  EventObj.FTimer.OnTimer := EventObj.TimerTick;
  EventObj.FTimer.Enabled := True;
  Result.CanResize := False;
end;

function Int2Digits( I, NDigits : Integer ) : String;
var M : String;
begin
  Result := Int2Str( I );
  M := '';
  if Result[ 1 ] = '-' then
  begin
    M := '-';
    Result := CopyEnd( Result, 2 );
  end;
  while Length( Result ) + Length( M ) < NDigits do
        Result := '0' + Result;
  Result := M + Result;
end;

function T2Str( const DT : TSystemTime ) : String;
begin
  Result := Int2Str( DT.wDay ) + '.' + Int2Digits( DT.wMonth, 2 ) + '.' +
            Int2Str( DT.wYear ) + ' ' + Int2Digits( DT.wHour, 2 ) + ':' +
            Int2Digits( DT.wMinute, 2 ) + ':' + Int2Digits( DT.wSecond, 2 );
end;

function Str2T( const T : String ) : TSystemTime;
var S : String;
begin
  S := T;
  Result.wDay := Str2Int( Parse( S, '.' ) );
  Result.wMonth := Str2Int( Parse( S, '.' ) );
  Result.wYear := Str2Int( Parse( S, ' ' ) );
  Result.wHour := Str2Int( Parse( S, ':' ) );
  Result.wMinute := Str2Int( Parse( S, ':' ) );
  Result.wSecond := Str2Int( S );
  Result.wMilliseconds := 0;
  Result.wDayOfWeek := 0;
end;

procedure LoadSaveIni( Ini: PIniFile; Mode: TIniFileMode );
  procedure X( const Key: String; var S: String );
  begin
    S := Ini.ValueString( Key, Int2Hex( Hex2Int( S ), 6 ) );
  end;
var S: String;
begin
  Ini.Mode := Mode;
  Ini.Section := 'Colors';
  X( 'HLink', CLink );
  X( 'VLink', VLink );
  X( 'ALink', ALink );
  X( 'BgColor', BgColor );
  X( 'TxColor', TxColor );
  X( 'HdColor', HdColor );
  X( 'Class', ColorClass );
  X( 'Name', ColorName );
  X( 'ReservedWord', ColorReserved );
  X( 'String', ColorString );
  X( 'Comment', ColorComment );
  X( 'Other', ColorOther );
  Ini.Section := 'Settings';
  TitleString := Ini.ValueString( 'Title', TitleString );
  LookSubfolders := Ini.ValueBoolean( 'Subfolders', LookSubfolders );
  S := Ini.ValueString( 'SpecialChar', '' + Special );
  if S <> '' then Special := S[ 1 ];
  UseWebdings := Ini.ValueBoolean( 'UseWebdings', UseWebdings );
  ParentHelp := Ini.ValueBoolean('ParentHelp', ParentHelp); {*BAP}
end;

procedure AccumulateFiles( const BasePath: String; Dir: PDirList );
var I: Integer;
    Dir1: PDirList;
    ST: TSystemTime;
    S: String;
begin
  Dir.Sort( [ ] );
  for I := 0 to Dir.Count - 1 do
  begin
    if LongBool( Dir.Items[ I ].dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY ) then
    begin
      if LookSubfolders then
      begin
        S := Dir.Path + Dir.Names[ I ]; // + '\';
        Dir1 := NewDirListEx( S, '*.*;*', FILE_ATTRIBUTE_NORMAL );
        S := BasePath + Dir.Names[ I ] + '\';
        AccumulateFiles( S, Dir1 );
        Dir1.Free;
      end;
    end
       else
    if LowerCase( ExtractFileExt( Dir.Names[ I ] ) ) = '.pas' then
    begin
      FileTimeToSystemTime( Dir.Items[ I ].ftLastWriteTime, ST );
      FileList.Add( ' ' + BasePath + Dir.Names[ I ] + ',' + T2Str( ST ) );
    end;
  end;
end;

procedure GenerateXclHelp;
var Ini : PIniFile;
    Dlg : POpenDirDialog;
    Dir : PDirList;
    I, J, N : Integer;
    S : String;
    Chg, ChgFile : Boolean;
    F : HFile;
    SysTime : TSystemTime;
    FileTime : TFileTime;
begin
  try
      S := GetCommandLine;
      if S[ 1 ] = '"' then
      begin
        S[ 1 ] := ' ';
        I := IndexOfChar( S, '"' );
      end
         else I := IndexOfChar( S, ' ' );
      if I > 1 then
      begin
        Param := Trim( CopyEnd( S, I + 1 ) );
        S := Copy( S, 1, I - 1 );
      end;
      ExePath := Trim( S );

      if Param <> '' then
      begin
        if Param[ 1 ] = '"' then
          Param := CopyEnd( Param, 2 );
        if (Param <> '') and (Param[ Length( Param ) ] = '"') then
          Param := Copy( Param, 1, Length( Param ) - 1 );
      end;
      if (Param <> '') and DirectoryExists( Param ) then
      begin
        SourcePath := Param;
        if SourcePath[ Length( SourcePath ) ] <> '\' then
          SourcePath := SourcePath + '\';
        IniDirPath := SourcePath;
        Ini := OpenIniFile( IniDirPath + 'XHelpGen.ini' );
        Ini.Section := 'Source';
      end
         else
      begin
        IniDirPath := GetStartDir;
        Ini := OpenIniFile( IniDirPath + 'XHelpGen.ini' );
        Ini.Section := 'Source';
        SourcePath := Ini.ValueString( 'SourcePath', IniDirPath );
      end;
      ResultPath := Ini.ValueString( 'ResultPath', SourcePath );
      if ResultPath = '' then
        ResultPath := SourcePath;
      if ResultPath[ Length( ResultPath ) ] <> '' then
        ResultPath[ Length( ResultPath ) ] := '\';
      UseJavaScript := Ini.ValueBoolean( 'UseJavaScript', False );
      S := Ini.Section; Ini.Section := 'Settings';
      LookSubfolders := Ini.ValueBoolean( 'Subfolders', LookSubfolders );
      Ini.Section := S;
      if (SourcePath = '') or not DirectoryExists( SourcePath ) then
      begin
        // Ask for path to XCL source
        Dlg := NewOpenDirDialog( 'Locate source directory', [ ] );
        if Dlg.Execute then
        begin
          SourcePath := Dlg.Path;
          Dlg.Free;
        end
           else
           Halt;
        Ini.Mode := ifmWrite;
        Ini.ValueString( 'SourcePath', SourcePath );
        Ini.Mode := ifmRead;
      end;
      if ResultPath = '' then
      begin
        CreateDirectory( PChar( ResultPath ), nil );
      end;
      if SourcePath <> '' then
      begin
        if CopyTail( SourcePath, 1 ) <> '\' then
           SourcePath := SourcePath + '\';
        Dir := NewDirListEx( SourcePath, '*.*;*', FILE_ATTRIBUTE_NORMAL );
        FileList := NewStrList;
        AccumulateFiles( '', Dir );
        Dir.Free;
        N := Ini.ValueInteger( 'FileCount', 0 );
        Chg := False;
        for I := 0 to FileList.Count - 1 do
        begin
          if N = FileList.Count then
          begin
            S := Ini.ValueString( 'File' + Int2Str( I + 1 ), '' );
            ChgFile := not StrEq( S, TrimLeft( FileList.Items[ I ] ) );
          end
            else
          begin
            ChgFile := True;
            for J := 0 to N - 1 do
            begin
              S := Ini.ValueString( 'File' + Int2Str( J + 1 ), '' );
              if StrEq( S, TrimLeft( FileList.Items[ I ] ) ) then
              begin
                ChgFile := False;
                break;
              end;
            end;
          end;
          if ChgFile then
          begin
            S := FileList.Items[ I ];
            S[ 1 ] := '*';
            FileList.Items[ I ] := S;
          end;
          if ChgFile then Chg := True;
        end;
        if N <> FileList.Count then Chg := True;
        if not Chg then
        begin
          S := ExePath;
          F := CreateFile( PChar( S ), GENERIC_READ,
               FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0 );
          if F > 0 then
          begin
            GetFileTime( F, nil, nil, @FileTime );
            FileTimeToSystemTime( FileTime, SysTime );
            S := Ini.ValueString( 'HelpGenVersion', '' );
            SysTime.wMilliseconds := 0;
            Chg := CompareSystemTime( Str2T( S ), SysTime ) <> 0;
            CloseHandle( F );
          end;
          if Chg then
          for I := 0 to FileList.Count - 1 do
          begin
            S := FileList.Items[ I ];
            S[ 1 ] := '*';
            FileList.Items[ I ] := S;
          end;
        end;
{*BAP BEGIN}
        if not Chg then
        begin
          Dir := NewDirListEx(ResultPath, '*.htm', FILE_ATTRIBUTE_NORMAL);
          if Dir.Count = 0 then
            Chg := True;
          Dir.Free;
        end;
{*BAP END}
        if Chg then
        begin
          Form1 := NewForm1( Applet );
        end;
      end;
      LoadSaveIni( Ini, ifmRead );
      LoadSaveIni( Ini, ifmWrite );
      Ini.Free;
  except
    //MsgOK( 'Error detected.' );
    raise;
  end;
end;

procedure RunXCLHelp;
var Cmd, S : String;
    I : Integer;
    L : PStrList;
    Flag : Word;
begin
  if Cancel then Exit;
  Cmd := GetCommandLine;
  if Cmd[ 1 ] = '"' then
  begin
    Cmd[ 1 ] := ' ';
    I := IndexOfChar( Cmd, '"' );
  end
     else I := IndexOfChar( Cmd, ' ' );
  if I <= 0 then Cmd := 'index.htm'
  else Cmd := Trim( CopyEnd( Cmd, I + 1 ) );
  S := Cmd;
  if StrIn( S, [ '-no', 'no', 'noopen', '-noopen' ] ) then
     Exit;
  I := IndexOfChar( Cmd, '#' );
  if I > 0 then S := Copy( S, 1, I - 1 );
  if not FileExists( ResultPath + S ) then
     Cmd := 'index.htm';
  Flag := SW_SHOW;

  if UseJavaScript then
  begin
    L := NewStrList;
    L.Add( '<html>' );
    L.Add( '<head>' );
    L.Add( '<title>KOL Help launcher</title>' );
    L.Add( '<base target="KOL Help window">' );
    L.Add( '</head>' );
    L.Add( '<body>' );
    L.Add( '<script language="JavaScript">' );
    L.Add( '  open( "' + Cmd + '" );' );
    L.Add( '  Window.close();' );
    L.Add( '</script>' );
    L.Add( '</body>' );
    L.Add( '</html>' );

    S := ResultPath + 'bat.htm';
    L.SaveToFile( S );
    L.Free;
    Flag := SW_HIDE;
  end
     else
  S := 'file:///' + ResultPath + Cmd;

  {
  while True do
  begin
    I := IndexOfChar( S, '\' );
    if I <= 0 then break;
    S[ I ] := '/';
  end;
  }

{* BAP
  if UseJavaScript then
  begin
    if ShellExecute( 0, 'open', 'iexplore.exe', PChar( S ), nil, Flag ) <= 32 then
    if ShellExecute( 0, 'open', PChar( S ), nil, nil, Flag ) <= 32 then
       ShellExecute( 0, 'open', 'explorer.exe', PChar( S ), nil, Flag );
  end
     else
  begin
    if ShellExecute( 0, 'open', PChar( S ), nil, nil, Flag ) <= 32 then
    if ShellExecute( 0, 'open', 'iexplore.exe', PChar( S ), nil, Flag ) <= 32 then
       ShellExecute( 0, 'open', 'explorer.exe', PChar( S ), nil, Flag );
  end;
* BAP}

{* BAP}
  if UseJavaScript then
  begin
    if ShellExecute( 0, nil, PChar( S ), nil, nil, Flag ) <= 32 then
    if ShellExecute( 0, 'open', 'iexplore.exe', PChar( S ), nil, Flag ) <= 32 then
       ShellExecute( 0, 'open', 'explorer.exe', PChar( S ), nil, Flag );
  end
     else
  begin
    if ShellExecute( 0, nil, PChar( S ), nil, nil, Flag ) <= 32 then
    if ShellExecute( 0, 'open', 'iexplore.exe', PChar( S ), nil, Flag ) <= 32 then
       ShellExecute( 0, 'open', 'explorer.exe', PChar( S ), nil, Flag );
  end;
{* BAP}
end;

{ XForm1 }

function ScanDescription( Descr : PStrList; U : PPascalUnit; Line : Integer ) : Boolean;
var S : String;
    I : Integer;
begin
  Result := False;
  Descr.Clear;
  while Line < U.Text.Count do
  begin
    S := Trim( U.Text.Items[ Line ] );
    if Copy( S, 1, 2 ) = '{' + Special then break;
    if Trim( U.CleanText[ Line ] ) <> '' then break;
    Inc( Line );
  end;
  if Copy( S, 1, 2 ) <> '{' + Special then Exit;
  S := Trim( CopyEnd( S, 3 ) );
  if (S + ' ')[ 1 ] = '!' then
  begin
    Result := True;
    S := CopyEnd( S, 2 );
  end;
  while Line < U.Text.Count do
  begin
    I := IndexOfChar( S, '}' );
    if I > 0 then
       S := Trim( Copy( S, 1, I - 1 ) );
    Descr.Add( S );
    if I > 0 then break;
    Inc( Line );
    S := U.Text.Items[ Line ];
  end;
  //Result := True;   //
end;

function ScanDescriptionFromStrings( Descr, RecDef : PStrList; Line: Integer )
         : Boolean;
var S : String;
    I : Integer;
begin
  Result := False;
  Descr.Clear;
  S := Trim( RecDef.Items[ Line ] );
  if Copy( S, 1, 2 ) <> '{' + Special then Exit;
  S := Trim( CopyEnd( S, 3 ) );
  if (S + ' ')[ 1 ] = '!' then
  begin
    Result := True;
    S := CopyEnd( S, 2 );
  end;
  while Line < RecDef.Count do
  begin
    I := IndexOfChar( S, '}' );
    if I > 0 then
       S := Trim( Copy( S, 1, I - 1 ) );
    Descr.Add( S );
    if I > 0 then break;
    Inc( Line );
    S := RecDef.Items[ Line ];
  end;
end;

function ScanDefinition( U : PPascalUnit; Pos1, Pos2 : TPoint ) : String;
var S : String;
    function ScanToBracket( Br : Char ) : String;
    var W : String;
    begin
      Result := '';
      while (W <> Br) and (ComparePositions( Pos1, Pos2 ) < 0) do
      begin
        W := U.Scan( Pos1 );
        //if W = Br then break;
        if W = '(' then
           Result := Result + '(' + ScanToBracket( ')' )
        else
        if W = '[' then
           Result := Result + '[' + ScanToBracket( ']' )
        else
        begin
          if ((Length( W ) = 1) and not (W[ 1 ] in [ ',', ';', '[', '(', '^',
             '*', ':' ])) or (Length( W ) > 1) then Result := Result + ' ';
          Result := Result + W;
        end;
      end;
    end;
begin

  Result := '';
  while ComparePositions( Pos1, Pos2 ) < 0 do
  begin
    S := U.Scan( Pos1 );
    if ComparePositions( U.StartTokenPos, Pos2 ) >= 0 then
       break;
    if S = '(' then
    begin
      Result := Result + '(' + ScanToBracket( ')' );
      continue;
    end
       else
    if S = '[' then
    begin
      Result := Result + '[' + ScanToBracket( ']' );
      continue;
    end;
    if StrIn( S, [ 'private', 'protected', 'public', 'end' ] ) then
        break;
    if ((Length( S ) = 1) and not (S[ 1 ] in [ ',', ';', '[', '(',
             '*', ':' ])) or (Length( S ) > 1) then Result := Result + ' ';
    Result := Result + S;
  end;

  Result := Trim( Result );
end;

procedure FillSubtopics( Topic : PTopic; Rec : PRecordClass; U : PPascalUnit );
    procedure FillSubtopicsWithTopicsOfType( ET : TEntryType; EventEnable : Boolean );
    var I, J, K : Integer;
        E : PEntry;
        S, S1, S2 : String;
        D : PStrList;
        T : TTopicType;
        SubTopic : PTopic;
        RO : TTriplean;
    begin
      for I := 0 to Rec.EntryCount - 1 do
      begin
        RO := No;
        E := Rec.Entries[ I ];
        if E.Section = stPrivate then continue;
        if E.EntryType <> ET then continue;
        T := Low( T );
        case E.EntryType of
        etField: T := ttField;
        etMethod: T := ttMethod;
        etProperty: T := ttProperty;
        end;
        if T = ttProperty then
           //if StrEq( Copy( E.Name, 1, 2 ), 'On' ) xor
           if ( (E.Name[ 1 ] = 'O') and (E.Name[ 2 ] = 'n') ) xor
              not EventEnable then continue;
        S := '';
        for J := E.EndPos.y + 1 to U.Text.Count - 1 do
        begin
          S := Trim( U.Text.Items[ J ] );
          if Copy( S, 1, 2 ) = '{' + Special then break;
          if Trim( U.CleanText[ J ] ) <> '' then break;
        end;
        if Copy( S, 1, 2 ) <> '{' + Special then continue;
        D := NewStrList;
        ScanDescription( D, U, E.EndPos.y + 1 );
        S := ScanDefinition( U, E.StartPos, E.EndPos );
        if T = ttProperty then
        begin
          //J := IndexOfStr( LowerCase(S), ' index ' );
          //if J <= 0 then
          J := IndexOfStr( LowerCase(S), ' read ' );
          K := IndexOfStr( LowerCase(S), ' write ' );
          RO := Unknown;
          if K > 0 then
             RO := No
          else
          if IndexOfChar( S, ':' ) > 0 then
             RO := Yes;
          if J <= 0 then
             J := K;
          if J > 0 then
          begin
            S1 := CopyEnd( S, J + 1 );
            Parse( S1, ' ' );
            K := IndexOfChar( S1, ';' );
            if K > 0 then
               S1 := CopyEnd( S1, K )
            else
               S1 := ';';
            S := Copy( S, 1, J ) ;
            for J := Length( S ) downto 1 do
                if S[ J ] = ':' then
                begin
                  S2 := CopyEnd( S, J + 1 );
                  K := IndexOfStr( S2, ' index ' );
                  if K > 0 then
                  begin
                     S2 := Copy( S2, 1, K );
                     S := Copy( S, 1, J ) + S2;
                  end;
                  break;
                end;
            if S1[ 1 ] = ';' then
               S := TrimRight( S );
            S := S + S1;
          end;
        end;
        SubTopic := NewTopic( Topic, T, E.Name, S, D );
        SubTopic.IsReadOnly := RO;
        if E.Section = stProtected then
           SubTopic.IsProtected := True;
      end;
    end;
begin
  FillSubtopicsWithTopicsOfType( etProperty, False );
  FillSubtopicsWithTopicsOfType( etField, False );
  FillSubtopicsWithTopicsOfType( etMethod, False );
  FillSubtopicsWithTopicsOfType( etProperty, True );
end;

function UnitTopicByName( const UnitName : String ) : PTopic;
var I : Integer;
    Topic : PTopic;
begin
  Result := nil;
  for I := 0 to UnitsList.Count - 1 do
  begin
    Topic := UnitsList.Items[ I ];
    if Topic.Name = UnitName {StrEq( Topic.Name, UnitName )} then
    begin
      Result := Topic;
      break;
    end;
  end;
end;

function ClassTopicByName( const ClassName : String ) : PTopic;
var I, J : Integer;
    UnitTopic, Topic : PTopic;
begin
  Result := nil;
  for I := 0 to UnitsList.Count - 1 do
  begin
    UnitTopic := UnitsList.Items[ I ];
    ////***\\\\ if UnitTopic.FTopics <> nil then
    for J := 0 to UnitTopic.FTopics.Count - 1 do
    begin
      Topic := UnitTopic.FTopics.Items[ J ];
      if Topic.TopicType = ttClass then
      if Topic.Name = ClassName{ StrEq( Topic.Name, ClassName )} then
      begin
        Result := Topic;
        Exit;
      end;
    end;
  end;
end;

function ValidString( const S : String ) : String;
var I, L : Integer;
    P : PChar;
begin
  L := Length( S );
  for I := 1 to Length( S ) do
  begin
    case S[ I ] of
    '&': L := L + 4;
    '"': L := L + 5;
    '<': L := L + 3;
    '>': L := L + 3;
    '|': L := L + 7;
    '`': L := L + 6;
    else ;
    end;
  end;
  if L = Length( S ) then
  begin
    Result := S;
    Exit;
  end;
  SetLength( Result, L );
  P := PChar( Result );
  for I := 1 to Length( S ) do
  begin
    case S[ I ] of
    '&': begin StrCopy( P, '&amp;' ); Inc( P, 5 ); end;
    '"': begin StrCopy( P, '&quot;' ); Inc( P, 6 ); end;
    '<': begin StrCopy( P, '&lt;' ); Inc( P, 4 ); end;
    '>': begin StrCopy( P, '&gt;' ); Inc( P, 4 ); end;
    '|': begin StrCopy( P, '&brvbar;' ); Inc( P, 8 ); end;
    '`': begin StrCopy( P, '&laquo;' ); Inc( P, 7 ); end;
    else begin P^ := S [ I ]; Inc( P ); end;
    end;
  end;
end;

function IsIdentifier( const S : String ) : Boolean;
var I : Integer;
begin
  Result := False;
  if S = '' then Exit;
  if not( S[ 1 ] in [ 'A'..'Z', 'a'..'z', '_' ] ) then Exit;
  Result := True;
  for I := 2 to Length( S ) do
      if not( S[ I ] in [ 'A'..'Z', 'a'..'z', '_', '0'..'9' ] ) then
      begin
        Result := False;
        break;
      end;
end;

function IsUnit( const S : String ) : String;
var I : Integer;
    U : PTopic;
begin
  Result := '';
  if CurrentUnit <> nil then
  if S = CurrentUnit.Name {StrEq( S, CurrentUnit.Name )} then Exit;
  for I := 0 to UnitsList.Count - 1 do
  begin
    U := UnitsList.Items[ I ];
    if S = U.Name {StrEq( U.Name, S )} then
    begin
      Result := U.HtName;//U.Order;
      break;
    end;
  end;
end;

function IsClass( const UnitName, S : String ) : String;
var I : Integer;
    U : PTopic;

    procedure SearchInUnit;
    var J : Integer;
        C : PTopic;
    begin
      for J := 0 to U.TopicsCount - 1 do
      begin
        C := U.Topics[ J ];
        if C.Name = S {StrEq( C.Name, S )} then
        begin
          Result := C.HtName;  //C.Order;
          Exit;
        end;
      end;
    end;
begin
  Result := '';
  if CurrentClass <> nil then
  if S = CurrentClass.Name {StrEq( S, CurrentClass.Name )} then Exit;
  if CurrentUnit <> nil then
  for I := 0 to UnitsList.Count - 1 do
  begin
    U := UnitsList.Items[ I ];
    if (UnitName = '') and (U.Name = CurrentUnit.Name) {StrEq( U.Name, CurrentUnit.Name )} or
       (UnitName <> '') and (U.Name = UnitName) {StrEq( U.Name, UnitName )} then
    begin
       SearchInUnit;
       break;
    end;
  end;
  if UnitName <> '' then Exit;
  for I := 0 to UnitsList.Count - 1 do
  begin
    U := UnitsList.Items[ I ];
    SearchInUnit;
    if Result <> '' then break;
  end;
end;

function IsReference( const S : String ) : String;
var I : Integer;
    ClassTopic, F : PTopic;
    R : String;
begin
  Result := '';
  if LowerCase( S ) = S then Exit;
  if CurrentUnit <> nil then
    if (S = CurrentUnit.Name) {StrEq( S, CurrentUnit.Name )} then Exit;
  if CurrentClass <> nil then
    if S = CurrentClass.Name {StrEq( S, CurrentClass.Name )} then
    begin
      if GeneratingUnit then
      if CurrentUnit = CurrentClass.ParentTopic then
         Result := CurrentClass.HtName;
      Exit;
    end;
  if CurrentTopic <> nil then
     if S = CurrentTopic.Name {StrEq( S, CurrentTopic.Name )} then Exit;
  R := IsUnit( S );
  if R <> '' then
  begin
    Result := R;
    Exit;
  end;
  if CurrentUnit <> nil then
  begin
    R := IsClass( CurrentUnit.Name, S );
    if R <> '' then
    begin
      if not GeneratingSample and GeneratingUnit then
        Result := '#' + LowerCase( S )
      else
      if (CurrentClass <> nil) and (CurrentClass.HtName = R) then
        Result := '#' + LowerCase( S ) + ' target="main"'
      else
        Result := R + ' target="_top"';
      Exit;
    end;
  end;
  if CurrentClass <> nil then
  begin
    ClassTopic := CurrentClass;
    while ClassTopic <> nil do
    begin
      for I := 0 to ClassTopic.TopicsCount - 1 do
      begin
        F := ClassTopic.Topics[ I ];
        if S = F.Name {StrEq( F.Name, S )} then
        begin
          Result := '#' + LowerCase( S );
          if not GeneratingSample and not GeneratingUnit then
             Result := Result + ' target="main"'
          else
             Result := ClassTopic.HtName + Result;
          Exit;
        end;
      end;
      if ClassTopic.Ancestor <> '' then
        ClassTopic := ClassTopicByName( ClassTopic.Ancestor )
      else
        ClassTopic := nil;
    end;
  end;
  R := IsClass( '', S );
  if R <> '' then
  begin
     Result := R;
     Exit;
  end;
end;

function ParseMacro( var Src : String; Htm : PStrList ) : String;
label loop;
var I, J, K, L, N, M : Integer;
    LM, S, Param : String;
    ParamList : PStrList;
begin
loop:
  if IndexOfChar( Src, '<' ) > 0 then
  for I := 1 to Length( Src ) - 1 do
  begin
    if (Src[ I ] = '<') and (Src[ I + 1 ] in [ 'A'..'Z', '0'..'9' ]) then
    begin
      for J := MacroList.Count - 1 downto 0 do
      begin
        if Src[ I + 1 ] = MacroList.Items[ J ][ 1 ] then
        begin
          if I = 1 then
          begin
            K := IndexOfChar( Src, '>' );
            if K < 0 then
            begin
              Result := Src;
              Src := '';
              Exit;
            end;
            M := 0;
            LM := MacroList.Items[ J ];
            for L := 1 to Length( LM ) - 1 do
            begin
              if (LM[ L ] = '%') and (LM[ L + 1 ] in [ '0'..'9' ]) then
              begin
                N := Integer( LM[ L + 1 ] ) - Integer( '0' );
                if N > M then M := N;
              end;
            end;
            Param := Trim( Copy( Src, 3, K - 3 ) );
            ParamList := NewStrList;
            ParamList.Add( Param );
            while Param <> '' do
            begin
              if ParamList.Count >= M then break;
              ParamList.Add( Trim( Parse( Param, ',' ) ) );
            end;
            if Param <> '' then
              ParamList.Add( Param );
            Src := CopyEnd( Src, K + 1 );
            S := '';
            K := 2;
            while K <= Length( MacroList.Items[ J ] ) do
            begin
              if MacroList.Items[ J ][ K ] = '%' then
              begin
                N := 0;
                while K < Length( MacroList.Items[ J ] ) do
                begin
                  Inc( K );
                  if MacroList.Items[ J ][ K ] in [ '0'..'9' ] then
                     N := N * 10 + Integer( MacroList.Items[ J ][ K ] ) - Integer( '0' )
                  else break;
                end;
                if N <= ParamList.Count - 1 then
                  S := S + ParamList.Items[ N ];
              end
                 else
              begin
                S := S + MacroList.Items[ J ][ K ];
                Inc( K );
              end;
            end;
            ParamList.Free;
            Htm.Add( S );
            goto loop;
          end
             else
          begin
            Result := Copy( Src, 1, I - 1 );
            Src := CopyEnd( Src, I );
            Exit;
          end;
        end;
      end;
    end;
  end;
  Result := Src;
  Src := '';
end;

procedure AddString2Htm( Htm : PStrList; S : String; Store : PStrList );
var L : String;
begin
  while S <> '' do
  begin
    L := ParseMacro( S, Htm );
    Htm.Add( L );
    if Store <> nil then
      Store.Add( L );
  end;
end;

procedure AddCustomGlossary2Htm( Htm: PStrList; const Ref: String );
var I: Integer;
    G: PGlossElt;
    //S: String;
begin
  Htm.Add( '<table border=0>' );
  for I := 0 to CustomRefs.Count - 1 do
  begin
    G := CustomRefs.Items[ I ];
    if G.Name = Ref then
    begin
      {S := '';
      if G.RefTopic.TopicType in [ ttMethod, ttProperty, ttField ] then
        S := '#' + G.RefTopic.Name;}
      Htm.Add( '<tr><td><a href="' + G.RefTopic.HtName + {S +} '" target=_top>' +
               G.RefTopic.Name + '</a></td><td>' + G.Text + '</td></tr>' );
    end;
  end;
  Htm.Add( '</table>' );
end;

function ValidName( const S: String ): String;
var I: Integer;
begin
  Result := '';
  for I := 0 to Length( S ) do
  begin
    if S[ I ] in [ 'A'..'Z', 'a'..'z', '0'..'9', '-', '_', '+' ] then
       Result := Result + S[ I ];
  end;
  if Result = '' then Result := 'sample';
end;

procedure AddTextToHtm( Htm, SrcTxt : PStrList; Store : PStrList ); forward;

procedure AddSample2Htm( Htm, Src: PStrList );
var
    I, J : Integer;
    R, W, S, F: String;
    S0: PChar;
    TmpList: PStrList;
begin
  GeneratingSample := True;

    Htm.Add( '<p align=left><font face="Courier" color="' + ColorOther + '"><b><pre>' );
    I := -1;
    while I < Src.Count - 1 do
    begin
      Inc( I );
      S := Src.Items[ I ];
      S0 := PChar( S );
      while (S0^ <> #0) and (S0^ <= ' ') do Inc( S0 );
      if S0^ = '|' then
      begin
        Inc( S0 );
        Htm.Add( '<font face="Arial" color="' + TxColor + '">' + S0 + '</font>' );
        continue;
      end;
      if S0^ = '!' then
      begin
        Inc( S0 );
        Htm.Add('</pre></b></font></p><p><font face="Arial" color="' + TxColor + '">');
        TmpList := NewStrList;
        TmpList.Add( S0 );
        while I < Src.Count - 1 do
        begin
          Inc( I );
          S := Src.Items[ I ];
          S0 := PChar( S );
          while (S0^ <> #0) and (S0^ <= ' ') do Inc( S0 );
          if S0^ = '!' then
          begin
            Inc( S0 );
            TmpList.Add( S0 );
          end
             else break;
        end;
        AddTextToHtm( Htm, TmpList, nil );
        TmpList.Free;
        Htm.Add('</font></p><p align=left><font face="Courier" color="' + ColorOther + '"><b><pre>');
      end;
      R := '';
      while S <> '' do
      begin
        J := IndexOfCharsMin( S, ' ,.;:()[]{/*$#<>=-+''' );
        if J <= 0 then
        begin
          W := S; S := '';
        end
           else
        begin
          if J = 1 then
          begin
            W := S[ 1 ];
            S := CopyEnd( S, 2 );
          end
             else
          begin
            W := Copy( S, 1, J - 1 );
            S := CopyEnd( S, J );
          end;
        end;
        case W[ 1 ] of
        '<',
        '>', ':': if (S <> '') and (S[ 1 ] = '=') then
                  begin
                    W := W + S[ 1 ]; S := CopyEnd( S, 2 );
                  end;
        '''': begin
                for J := 1 to Length( S ) do
                begin
                  if S[ J ] = '''' then
                    if (J = Length( S )) or (S[ J + 1 ] <> '''') then
                    begin
                      W := '<font color="'+ ColorString + '">' + W + Copy(S, 1, J) + '</font>';
                      S := CopyEnd( S, J + 1 );
                      break;
                    end;
                end;
              end;
        '/': if (S <> '') and (S[ 1 ] = '/') then
             begin
               W := '</b><font color="' + ColorComment + '"><em>/' + S + '</em></font><b>';
               S := '';
             end;
        ' ', '.', ',', '(', ')', '[', ']', '+', '-', '=', ';', '*', '#', '$': ;
        else if StrIn( W, [ 'asm', 'assembler', 'as', 'and', 'begin', 'break', 'boolean', 'continue',
                'case', 'const', 'class', 'do', 'downto', 'div', 'end', 'else', 'for', 'forward',
                'function', 'goto', 'if', 'in', 'is', 'inherited', 'integer',
                'library', 'mod', 'of', 'or', 'object', 'override', 'procedure',
                'program', 'interface',
                'property', 'private', 'protected', 'repeat', 'shl', 'shr', 'string',
                'to', 'type', 'then', 'threadvar', 'unit', 'until', 'var', 'virtual',
                'while', 'with', 'xor' ] ) then
             begin
               W := '<font color="' + ColorReserved + '"><b>' + W + '</b></font>';
             end
                else
             begin
               F := IsReference( W );
               if F <> '' then
                 W := '<a href="' + F + '"><font color="' + ColorOther + '">' + W + '</font></a>';
             end;
        end;
        R := R + W;
      end;
      Htm.Add( R );
    end;
    Htm.Add( '</pre></b></font></p>' );

  GeneratingSample := False;
end;

procedure CreateSampleHtm( const HtmAddr, HtmTitle: String; Src: PStrList );
var Htm: PStrList;
    CurTopic: PTopic;
begin
  CurTopic := CurrentTopic;
  CurrentTopic := nil;
  GeneratingSample := True;

  Htm := NewStrList;
    Htm.Add( '<html>' );
    Htm.Add( '' );
    Htm.Add( '<head>' );
    Htm.Add( '<title>' + TitleString + ': ' + HtmTitle + '</title>' );
    Htm.Add( '</head>' );
    Htm.Add( '' );
    Htm.Add( '<body bgcolor="#' + BgColor + '" text="#' + TxColor + '" link="#' + CLink +'" vlink="#' + VLink + '" alink="#' + ALink + '">' );
    Htm.Add( '' );
    Htm.Add( '<h1 align="center">' );
    Htm.Add( '<font face="Arial" color="#' + HdColor + '">' + HtmTitle + '</font>' );
    Htm.Add( '</h1>' );
    AddTextToHtm( Htm, Src, nil );
    Htm.Add( '<hr>' );
    Htm.Add( '<p align="center"><font face="Comic Sans MS"><small>This help is generated ' + cVK_BAP);
    Htm.Add( '</body>' );
    Htm.Add( '</html>' );
  Htm.SaveToFile( ResultPath + HtmAddr );
  Htm.Free;

  GeneratingSample := False;
  CurrentTopic := CurTopic;
end;

procedure AddTextToHtm( Htm, SrcTxt : PStrList; Store : PStrList );
var I, J, K : Integer;
    S, S1: PChar;
    C: Char;
    R, W, W1, W2, Ref, Src, V : String;
    InsSpc : Boolean;
    SmpList: PStrList;

    function ParseToSp( var S : PChar ) : String;
    var S0: PChar;
    begin
      Result := '';
      if S^ = #0 then Exit;
      if S^ = ' ' then
      begin
        Result := ' ';
        Inc( S );
        Exit;
      end;
      S0 := S;
      while (S^ > ' ') do Inc( S );
      Result := Copy( S0, 1, Integer( S ) - Integer( S0 ) );
    end;
begin
  if Store <> nil then
  begin
     Htm.AddStrings( Store );
     exit;
  end;
  I := -1;
  while I < SrcTxt.Count - 1 do
  begin
    Inc( I );
    S := SrcTxt.ItemPtrs[ I ];
    while (S^ <> #0) and (S^ <= ' ') do Inc( S );
    if S^ = '!' then
    begin
      Inc( S );
      SmpList := NewStrList;
      SmpList.Add( S );
      while I < SrcTxt.Count - 1 do
      begin
        Inc( I );
        S := SrcTxt.ItemPtrs[ I ];
        while (S^ <> #0) and (S^ <= ' ') do Inc( S );
        if S^ <> '!' then break;
        Inc( S );
        SmpList.Add( S );
      end;
      AddSample2Htm( Htm, SmpList );
      SmpList.Free;
      if I >= SrcTxt.Count - 1 then break;
    end;
    if S^ = '|' then
    begin // insert as is, if line is starting from '|'
      Inc( S );
      if S^ = '&' then
      begin
        C := S[ 1 ];
        if (C <> #0) and (C in [ 'A'..'Z', '0'..'9' ]) and
           (S[2] = '=') then
          MacroList.Add( '' + C + PChar( @S[3] ) )
        else
          Htm.Add( '<br>INCORRECT MACROS: ' + ValidString( S ) + '<br>' );
        CONTINUE;
      end
         else
      if S^ = '*' then
      begin // insert link to sample and generate sample html
        Inc( S );
        W := ValidName( S ) + '.htm';
        if UseWebdings then
          Htm.Add( '&nbsp;&nbsp;&nbsp;<a href="' + W + '"><font face="Webdings" size=7>&#181;</font></a>&nbsp;&nbsp;&nbsp;' )
        else
          Htm.Add( '<a href="' + W + '"><img src="sample.gif" width=70 height=40 align=right title="' + S + '" border=0></a>' );
        S1 := S;
        SmpList := NewStrList;
        while I < SrcTxt.Count - 1 do
        begin
          Inc( I );
          S := SrcTxt.ItemPtrs[ I ];
          while (S^ <> #0) and (S^ <= ' ') do Inc( S );
          if (S^ = '|') and (S[ 1 ] = '*') then break;
          SmpList.Add( SrcTxt.ItemPtrs[ I ] );
        end;
        CreateSampleHtm( W, S1, SmpList );
        SmpList.Free;
        continue;
      end
         else
      if S^ = '#' then
      begin
        Inc( S );
        Ref := Trim( S );
        AddCustomGlossary2Htm( Htm, Ref );
        S := nil;
        break;
      end
        else
      begin
        AddString2Htm( Htm, S, nil );
        continue;
      end;
    end;
    Src := S;
    while Src <> '' do
    BEGIN
      V := ValidString( ParseMacro( Src, Htm ) );
      while pos( ''#9, V ) > 0 do
        V[ pos( ''#9, V ) ] := ' ';
      S := PChar( V );
      R := '';
      InsSpc := S^ = ' ';
      while S^ <> #0 do
      begin
        J := IndexOfCharsMin( S, ' .,;:!?()[]+-''"' );
        if J > 0 then
        begin
          if (S[ J - 1 ] = '.') and (S[ J ] > ' ') then
          begin
            S[ J - 1 ] := '^';
            K := IndexOfCharsMin( S, ' .,;:!?()[]+-''"' );
            S[ J - 1 ] := '.';
            if K > 0 then
            begin
              W := Copy( S, 1, K - 1 );
              Inc( S, K - 1 );
            end
               else
               W := ParseToSp( S );
          end
             else
          if S[ J - 1 ] = ' ' then
             W := ParseToSp( S )
          else
          if J > 1 then
          begin
            W := Copy( S, 1, J - 1 );
            Inc( S, J - 1 );
          end
             else
          begin
            R := R + S^;
            Inc( S );
            continue;
          end;
        end
           else
           W := ParseToSp( S );
        J := -1;
        if (W <> '') and (W[ 1 ] <> ' ') then
          J := IndexOfChar( W, '.' );
        Ref := '';
        if J > 0 then
        begin
          W1 := Copy( W, 1, J - 1 );
          W2 := CopyEnd( W, J + 1 );
          if IsIdentifier( W1 ) and IsIdentifier( W2 ) then
          begin
            if StrEq( W2, 'pas' ) then
              Ref := IsUnit( W1 )
            else
            begin
              Ref := IsClass( '', W1 );
              if Ref = '' then
              begin
                Ref := IsUnit( W1 );
                if Ref <> '' then
                begin
                  if IsClass( W1, W2 ) = '' then
                     Ref := ''
                  else
                     Ref := Ref + '#' + LowerCase( W2 );
                end;
              end
                 else
              begin
                Ref := Ref + '#' + LowerCase( W2 );
              end;
            end;
          end;
        end
           else
        if IsIdentifier( W ) then
        begin
          Ref := IsReference( W );
        end;
        if Ref <> '' then
           W := '<a href=' + Ref + '>' + W + '</a>';
        if InsSpc then R := R + ' ';
        R := R + W;
        InsSpc := False;
      end;
      R := Trim( R );
      Htm.Add( R );
    END;
  end;
end;

procedure AddDefToHtm( Htm : PStrList; Def : String; Topic: PTopic; const FontColor: String );
var W, U, R, Ref : String;
    I : Integer;

    function IsReservedWord( const W : String ) : Boolean;
    begin
      Result := StrIn( W, [ 'procedure', 'function', 'constructor', 'destructor',
                       'var', 'const', 'array', 'record', 'object', 'of',
                       'override', 'virtual', 'dynamic', 'reintroduce',
                       'overload', 'assembler', 'asm', 'begin', 'end', 'class',
                       'property', 'read', 'write', 'set', 'integer', 'string',
                       'boolean', 'double', 'float', 'dword', 'word', 'byte',
                       'char', 'pointer', 'pchar', 'tobject', 'case', 'abstract',
                       'packed', 'type', 'case', 'is', 'as', 'in', 'if', 'interface',
                       'then', 'else', 'try', 'finally', 'on', 'except',
                       'initialization', 'finalization', 'label', 'out',
                       'default', 'nodefault', 'stored', 'implements' ] );
    end;
begin
  Def := ValidString( Def );
  R := '';
  while Def <> '' do
  begin
    I := IndexOfCharsMin( Def, ' .,;()[]+-:' );
    if I <= 0 then
    begin
       W := Parse( Def, ' ' );
       if IsReservedWord( W ) then
          W := '<b>' + W + '</b>';
    end
       else
    begin
      if (I > 1) and (Def[ I ] in [ ' ',';','(' ]) and
         IsReservedWord( Copy( Def, 1, I - 1 ) ) then
      begin
        W := Copy( Def, 1, I - 1 );
        Def := CopyEnd( Def, I );
        W := '<b>' + W + '</b>';
      end
         else
      begin
        if (I > 1) and (Def[ I ] = '.') and ((CopyEnd( Def, I + 1 ) + ' ')[ 1 ] > ' ') then
        begin
          U := Parse( Def, '.' );
          I := IndexOfCharsMin( Def, ' .,;()[]+-:' );
          if I <= 0 then
          begin
            W := U + '.' + Parse( Def, ' ' );
            if Def <> '' then Def := ' ' + Def;
          end
            else
          if Def[ I ] in [ '(',')','[',']',';',',',' ' ] then
          begin
            W := Copy( Def, 1, I - 1 );
            Def := CopyEnd( Def, I );
            Ref := IsUnit( U );
            if Ref <> '' then
            begin
              if IsClass( U, W ) <> '' then
              begin
                R := R + ' <a href=' + Ref + '#' + LowerCase( W ) +
                     '>' + U + '.' + W + '</a>';
                continue;
              end;
            end
               else
            begin
              Ref := IsClass( '', U );
              if Ref <> '' then
              begin
                R := R + ' <a href=' + Ref + '#' + LowerCase( W ) +
                     '>' + U + '.' + W + '</a>';
                continue;
              end;
            end;
          end;
          W := U + '.' + W;
        end
           else
        if I > 1 then
        begin
          if Def[ I ] = ' ' then
          begin
             //W := Parse( Def, ' ' )
             W := Copy( Def, 1, I - 1 );
             Def := CopyEnd( Def, I );
          end
             else
          begin
            W := Copy( Def, 1, I - 1 );
            Def := CopyEnd( Def, I );
          end;
          if (CurrentTopic <> nil) and (CurrentTopic.Name = W) then
             W := '<font color="#' + ColorClass + '"><b>' + W + '</b></font>'
          else
          begin
            U := IsReference( W );
            if U <> '' then
            begin
              if GeneratingUnit then
              if (CurrentClass <> nil) and (CurrentClass.Name = W) then
                 W := '<b>' + W + '</b>';
              if CopyTail( U, Length( Topic.Name ) + 1 ) <> '#' + LowerCase(Topic.Name) then
                 W := '<a href=' + U + '>' + W + '</a>';
            end;
          end;
        end
           else
        begin
          R := R + Def[ 1 ];
          Def := CopyEnd( Def, 2 );
          continue;
        end;
      end;
    end;
    R := R + W;
  end;
  R := Trim( R );
  if FontColor = '' then
       R := '<font face="Courier" color="#' + ColorName + '">' + R + '</font>'
  else R := '<font face="Courier" color="#' + FontColor + '">' + R + '</font>';
  Htm.Add( R );
end;

function PropCount( Topic : PTopic; Recursive : Boolean ) : Integer;
var I : Integer;
    SubTopic : PTopic;
begin
  Result := 0;
  if Topic.TopicType <> ttClass then Exit;
  for I := 0 to Topic.TopicsCount - 1 do
  begin
    SubTopic := Topic.Topics[ I ];
    if SubTopic.TopicType = ttProperty then
    //if not StrEq( Copy( SubTopic.Name, 1, 2 ), 'On' ) then
    if not ( (SubTopic.Name[ 1 ] = 'O') and (SubTopic.Name[ 2 ] = 'n') ) then 
       Inc( Result );
  end;
  if Recursive then
  if Topic.Ancestor <> '' then
  begin
    Topic := ClassTopicByName( Topic.Ancestor );
    if Topic <> nil then
       Result := Result + PropCount( Topic, Recursive );
  end;
end;

function MethodCount( Topic : PTopic; Recursive : Boolean ) : Integer;
var I : Integer;
    SubTopic : PTopic;
begin
  Result := 0;
  if Topic.TopicType <> ttClass then Exit;
  for I := 0 to Topic.TopicsCount - 1 do
  begin
    SubTopic := Topic.Topics[ I ];
    if SubTopic.TopicType = ttMethod then
       Inc( Result );
  end;
  if Recursive then
  if Topic.Ancestor <> '' then
  begin
    Topic := ClassTopicByName( Topic.Ancestor );
    if Topic <> nil then
       Result := Result + MethodCount( Topic, Recursive );
  end;
end;

function EventCount( Topic : PTopic; Recursive : Boolean ) : Integer;
var I : Integer;
    SubTopic : PTopic;
begin
  Result := 0;
  if Topic.TopicType <> ttClass then Exit;
  for I := 0 to Topic.TopicsCount - 1 do
  begin
    SubTopic := Topic.Topics[ I ];
    if SubTopic.TopicType = ttProperty then
    //if StrEq( copy( SubTopic.Name, 1, 2 ), 'On' ) then
    if (Subtopic.Name[ 1 ] = 'O') and (Subtopic.Name[ 2 ] = 'n') then
       Inc( Result );
  end;
  if Recursive then
  if Topic.Ancestor <> '' then
  begin
    Topic := ClassTopicByName( Topic.Ancestor );
    if Topic <> nil then
       Result := Result + EventCount( Topic, Recursive );
  end;
end;

function FieldCount( Topic : PTopic; Recursive : Boolean ) : Integer;
var I : Integer;
    SubTopic : PTopic;
begin
  Result := 0;
  if Topic.TopicType <> ttClass then Exit;
  for I := 0 to Topic.TopicsCount - 1 do
  begin
    SubTopic := Topic.Topics[ I ];
    if SubTopic.TopicType = ttField then
       Inc( Result );
  end;
  if Recursive then
  if Topic.Ancestor <> '' then
  begin
    Topic := ClassTopicByName( Topic.Ancestor );
    if Topic <> nil then
       Result := Result + FieldCount( Topic, Recursive );
  end;
end;

procedure AddDefsToClassHtm( Htm: PStrList; Topic: PTopic; AddType : TTopicType; EnableEvents : Boolean);
label L1, L2;
var I, J : Integer;
    SubTopic : PTopic;
    TypeName: String;
    Cursive : Boolean;
    S : String;
    Defined : PStrList;
    AncTopic, AncSubTopic : PTopic;
    Tmp, Tmp0 : PStrList;
begin
  Cursive := False;
  Defined := NewStrList;
  L1:
  for I := 0 to Topic.TopicsCount - 1 do
  begin
    SubTopic := Topic.Topics[ I ];
    if SubTopic.TopicType = AddType then
    if (AddType = ttProperty) and
       EnableEvents and //StrEq( Copy( SubTopic.Name, 1, 2 ), 'On' )
       (Subtopic.Name[ 1 ] = 'O') and (Subtopic.Name[ 2 ] = 'n')
    or (not EnableEvents) and //(not StrEq( Copy( SubTopic.Name, 1, 2 ), 'On' )) then
    not( (Subtopic.Name[ 1 ] = 'O') and (Subtopic.Name[ 2 ] = 'n') ) then
    begin
      //if Defined.IndexOf( LowerCase( SubTopic.Name ) ) < 0 then
      begin
        S := '';
        if Cursive then
           S := LowerCase( Topic.Name ) + '_';
        Htm.Add( '<a name="' + S + LowerCase( SubTopic.Name ) + '"></a>' );
        Htm.Add( '<p>' );
        if S <> '' then
           Htm.Add( '<a name="' + LowerCase( SubTopic.Name ) + '"></a>' );
        CurrentTopic := SubTopic;
        if Cursive then
           Htm.Add( '<em>' );
        AddDefToHtm( Htm, SubTopic.Definition, SubTopic, '' );
        if SubTopic.IsProtected then
        begin
          if UseWebdings then
            Htm.Add( '&nbsp;&nbsp;&nbsp;<font face="Webdings" size=7>&#78;</font>&nbsp;&nbsp;&nbsp;' )
          else
            Htm.Add( '<img src=protect.gif border=0 align=absmiddle title="Protected">' );
        end;
        if (AddType = ttProperty) and not EnableEvents then
        if SubTopic.IsReadOnly = Yes then
        begin
          if UseWebdings then
            Htm.Add( '&nbsp;&nbsp;&nbsp;<font face="Webdings" size=7>&#209;</font>&nbsp;&nbsp;&nbsp;' )
          else
            Htm.Add( '<img src=readonly.gif border=0 align=absmiddle title="ReadOnly">' );
        end;
        if Cursive then
           Htm.Add( '</em>' );
        Htm.Add( '<br>' );
        if (SubTopic.Description.Count > 1) or
           (SubTopic.Description.Count > 0) and (SubTopic.Description.Items[ 0 ] <> '') then
           AddTextToHtm( Htm, SubTopic.Description, SubTopic.FDescrText )
        else
        begin
          AncTopic := Topic;
          AncSubTopic := nil;
          while AncTopic.Ancestor <> '' do
          begin
            AncTopic := ClassTopicByName( AncTopic.Ancestor );
            if AncTopic = nil then break;
            for J := 0 to AncTopic.TopicsCount - 1 do
            begin
              AncSubTopic := AncTopic.Topics[ J ];
              //if StrEq( AncSubTopic.Name, SubTopic.Name ) then
              if AncTopic.Name = SubTopic.Name then
                 break
              else AncSubTopic := nil;
            end;
            if AncSubTopic <> nil then break;
          end;
          if AncSubTopic <> nil then
          begin
            Tmp := NewStrList;
            //Tmp.AddStrings( AncSubTopic.Description );
            //Tmp.Add( '|<br>&nbsp;&nbsp;&nbsp;' );
            if IndexOfStr( LowerCase( SubTopic.Definition ), ' override;' ) > 0 then
            begin
               Tmp.Add( 'Overriden in ' + Topic.Name );
               if AncSubTopic.IsProtected and not
                  SubTopic.IsProtected then
                  Tmp.Add( ' and moved from ''protected'' section to ''public'' one' );
               Tmp.Add( '. ' );
            end
               else
            if AncSubTopic.IsProtected and not SubTopic.IsProtected then
               Tmp.Add( 'Moved into ''public'' section. ' )
            else
            if AncSubTopic.Description.Count < 5 then
            begin
               if AncSubTopic.DescrText <> nil then
                  for J := 0 to AncSubTopic.DescrText.Count - 1 do
                      Tmp.Add( '|' + AncSubTopic.DescrText.Items[ J ] )
               else
               Tmp.AddStrings( AncSubTopic.Description );
            end;
            Tmp.Add( 'See also definition of inherited (' + AncSubTopic.ParentTopic.Name +
                     '.' + AncSubTopic.Name + ').' );
            Tmp0 := nil;
            AddTextToHtm( Htm, Tmp, Tmp0 );
            Tmp.Free;
            Tmp0.Free;
          end;
        end;
        CurrentTopic := nil;
        Htm.Add( '</p>' );
        Defined.Add( LowerCase( SubTopic.Name ) );
      end;
    end;
  end;
  L2:
  if Topic.Ancestor <> '' then
  begin
    SubTopic := ClassTopicByName( Topic.Ancestor );
    if SubTopic = nil then Exit;
{*BAP BEGIN}
    if ParentHelp then
    begin
{*BAP END}
    I := 0;
    TypeName := '';
    AncTopic := nil;
    if SubTopic.Ancestor <> '' then
       AncTopic := ClassTopicByName( SubTopic.Ancestor );
    case AddType of
    ttMethod:
      begin
        if AncTopic <> nil then
           I := MethodCount( SubTopic, True ) - MethodCount( AncTopic, True )
        else
           I := MethodCount( SubTopic, False );
        TypeName := 'Methods';
      end;
    ttField:
      begin
        if AncTopic <> nil then
           I := FieldCount( SubTopic, True ) - FieldCount( AncTopic, True )
        else
           I := FieldCount( SubTopic, False );
        TypeName := 'Fields';
      end;
    ttProperty:
      if EnableEvents then
      begin
        if AncTopic <> nil then
           I := EventCount( SubTopic, True ) - EventCount( AncTopic, True )
        else
           I := EventCount( SubTopic, False );
        TypeName := 'Events';
      end
         else
      begin
        if AncTopic <> nil then
           I := PropCount( SubTopic, True ) - PropCount( AncTopic, True )
        else
           I := PropCount( SubTopic, False );
        TypeName := 'Properties';
      end;
    end;
    Topic := SubTopic;
    if I > 0 then
    begin
      Htm.Add( '<h4 align="center"><font color="#' + HdColor + '">' + TypeName + ', inherited from ' +
               '<a href="' + SubTopic.HtName + '" target="_top">' + SubTopic.Name + '</a>' +
               '</font></h4>' );
      Cursive := True;
      goto L1;
    end;
    goto L2;
{*BAP BEGIN}
    end else
    begin
      case AddType of
        ttMethod: TypeName := 'Methods';
        ttField: TypeName := 'Fields';
        ttProperty:
          if EnableEvents then
            TypeName := 'Events'
          else
            TypeName := 'Properties';
      end;
      Htm.Add('<h4 align="center"><font color="black">' + TypeName +
        ', inherited from ' + '<a href="' + SubTopic.HtName +
        '" target="_top">' + SubTopic.Name + '</a>' + '</font></h4>');
    end;
{*BAP END}
  end;
  Defined.Free;
end;

procedure AddRefsToLeftHtm( Htm: PStrList; Topic: PTopic; AddType : TTopicType; EnableEvents : Boolean);
label L1, L2;
var I : Integer;
    MainTopic, SubTopic, AncTopic : PTopic;
    TypeName: String;
    Cursive : Boolean;
    S : String;
    Defined : PStrList;
    SHtm: PStrList; {*BAP}
begin
  Cursive := False;
  MainTopic := Topic;
  Defined := NewStrList;
  SHtm := NewStrList; {*BAP}
  L1:
  for I := 0 to Topic.TopicsCount - 1 do
  begin
    SubTopic := Topic.Topics[ I ];
    if SubTopic.TopicType = AddType then
    if (AddType = ttProperty) and
       EnableEvents and //StrEq( Copy( SubTopic.Name, 1, 2 ), 'On' )
       (Subtopic.Name[ 1 ] = 'O') and (Subtopic.Name[ 2 ] = 'n')
    or (not EnableEvents) and //(not StrEq( Copy( SubTopic.Name, 1, 2 ), 'On' )) then
    not( (Subtopic.Name[ 1 ] = 'O') and (Subtopic.Name[ 2 ] = 'n') ) then
    begin
      if Defined.IndexOf( LowerCase( SubTopic.Name ) ) < 0 then
      begin
        S := '';
        if Cursive then
           S := LowerCase( Topic.Name ) + '_';
        S := '<a href=main_' + MainTopic.HtName + '#' +
             S + LowerCase( Subtopic.Name ) + '>' +
                 SubTopic.Name + '</a>';
        if Cursive then
           S := '<em>' + S + '</em>';
        if (not SubTopic.FProtected) and (not Cursive) then
           S := '<b>' + S + '</b>';
        S := S + '<br>';
        SHtm.Add(S); {*BAP Htm.Add( S );}
        Defined.Add( LowerCase( SubTopic.Name ) );
      end;
    end;
  end;
{*BAP BEGIN}
  SHtm.Sort(True);
  for I := 0 to Topic.TopicsCount - 1 do
    Htm.Add(SHtm.Items[I]);
  SHtm.Clear;
{*BAP END}
  L2:
  if Topic.Ancestor <> '' then
  begin
    SubTopic := ClassTopicByName( Topic.Ancestor );
    if SubTopic = nil then
    begin
      SHtm.Free; {*BAP}
      Defined.Free;
      Exit;
    end;
{*BAP BEGIN}
    if ParentHelp then
    begin
{*BAP END}
    I := 0;
    TypeName := '';
    AncTopic := nil;
    if SubTopic.Ancestor <> '' then
       AncTopic := ClassTopicByName( SubTopic.Ancestor );
    case AddType of
    ttMethod:
      begin
        if AncTopic <> nil then
           I := MethodCount( SubTopic, True ) - MethodCount( AncTopic, True )
        else
           I := MethodCount( SubTopic, False );
        TypeName := 'Methods';
      end;
    ttField:
      begin
        if AncTopic <> nil then
           I := FieldCount( SubTopic, True ) - FieldCount( AncTopic, True )
        else
           I := FieldCount( SubTopic, False );
        TypeName := 'Fields';
      end;
    ttProperty:
      if EnableEvents then
      begin
        if AncTopic <> nil then
           I := EventCount( SubTopic, True ) - EventCount( AncTopic, True )
        else
           I := EventCount( SubTopic, False );
        TypeName := 'Events';
      end
         else
      begin
        if AncTopic <> nil then
           I := PropCount( SubTopic, True ) - PropCount( AncTopic, True )
        else
           I := PropCount( SubTopic, False );
        TypeName := 'Properties';
      end;
    end;
    Topic := SubTopic;
    if I > 0 then
    begin
      Htm.Add( '<p align="center"><em>from&nbsp;<a href="' + SubTopic.HtName +
               '" target="_top">' + SubTopic.Name + '</a></em></p>' );
      Cursive := True;
      goto L1;
    end;
    goto L2;
{*BAP BEGIN}
    end else
      Htm.Add('<p align="center"><em><font color="black">from&nbsp;</font><a href="' +
        SubTopic.HtName + '" target="_top">' + SubTopic.Name + '</a></em></p>');
{*BAP END}
  end;
  SHtm.Free; {*BAP}
  Defined.Free;
end;

var TreeLevel : Integer = 0;
procedure AddClassTreeToHtm( Htm : PStrList; Node: PTree );
var I : Integer;
    Topic : PTopic;
    SubNode : PTree;
    S : String;

    {function Level( Node : PTree ) : Integer;
    begin
      Result := 0;
      while Node.Parent <> nil do
      begin
        Inc( Result );
        Node := Node.ParentNode;
      end;
    end;}

begin
  Inc( TreeLevel );
  if (not DynamicTree) or (Node.Count = Node.Total) then
  BEGIN
    if DynamicTree then
    begin
      Htm.Add( '<table dynoutline border=0 cellpadding=0 cellspacing=0 width="100%">' );
      for I := 0 to Node.Count - 1 do
      begin
        SubNode := Node.Items[ I ];
        Topic := SubNode.Data;
        if Topic = nil then continue;
        S := Topic.Name;
        if Topic.FSigh then
           S := '<b>' + S + '</b>';
        Htm.Add( '<tr>' );
        Htm.Add( '  <td valign=baseline width=16>' );
        if UseWebdings then
          Htm.Add( '  <font face="Webdings">&#110;</font>&nbsp;&nbsp;</td>' )
        else
          Htm.Add( '  <img src="roundbul.gif" width=8 height=8 align=baseline hspace=2></td>' );
        Htm.Add( '  <td valign=top width="*">' );
        Htm.Add( '  <a href=' + Topic.HtName + '>' + S + '</a>' );
        if SubNode.Count > 0 then
          AddClassTreeToHtm( Htm, SubNode );
        Htm.Add( '  </td>' );
        Htm.Add( '</tr>' );
      end;
      Htm.Add( '</table>' );
    end
       else
    BEGIN
      Htm.Add( '<ul compact>' );
      for I := 0 to Node.Count - 1 do
      begin
        SubNode := Node.Items[ I ];
        Topic := SubNode.Data;
        if Topic = nil then continue;
        S := Topic.Name;
        if Topic.FSigh then
           S := '<b>' + S + '</b>';
        Htm.Add( '<li><a href=' + Topic.HtName + '>' + S + '</a></li>' );
        if SubNode.Count > 0 then
          AddClassTreeToHtm( Htm, SubNode );
      end;
      Htm.Add( '</ul>' );
    END;
  END
     ELSE
  BEGIN
    if Node.Level <= 1 then
      Htm.Add( '<table dynoutline border=0 cellpadding=0 cellspacing=0 width="100%">' )
    else
      Htm.Add( '<table dynoutline border=0 cellpadding=0 cellspacing=0 width="100%"' +
               ' style="display:none">' );
    for I := 0 to Node.Count - 1 do
    begin
      SubNode := Node.Items[ I ];
      Topic := SubNode.Data;
      if Topic = nil then continue;
      S := Topic.Name;
      if Topic.FSigh then
         S := '<b>' + S + '</b>';
      Htm.Add( '<tr>' );
      if (I = 0) and (TreeLevel = 1) then
        Htm.Add( '  <td valign=baseline width=16 id="FirstClassNode">' )
      else
      {
      if (I = Node.Count - 1) and (TreeLevel = 1) then
        Htm.Add( '  <td valign=baseline width=16 id="LastClassNode">' )
      else
      }
        Htm.Add( '  <td valign=baseline width=16>' );
      if SubNode.Count > 0 then
      begin
        if UseWebdings then
          Htm.Add( '<font face="Webdings" onClick="doOutline();">&#99;</font>&nbsp;&nbsp;</td>' )
        else
          Htm.Add( '  <img src="bullet.gif" width=8 height=8 align=baseline hspace=2' +
                   ' onClick="doOutline();"></td>' )
      end
        else
      begin
        if UseWebdings then
          Htm.Add( '<font face="Webdings">&#110;</font>&nbsp;&nbsp;</td>' )
        else
          Htm.Add( '  <img src="roundbul.gif" width=8 height=8 align=baseline hspace=2' +
                   '></td>' );
      end;
      Htm.Add( '  <td valign=top width="*">' );
      Htm.Add( '  <a href=' + Topic.HtName + '>' + S + '</a>' );
      if SubNode.Count > 0 then
        AddClassTreeToHtm( Htm, SubNode );
      Htm.Add( '  </td>' );
      Htm.Add( '</tr>' );
    end;
    if TreeLevel = 1 then
      Htm.Add( '  <tr><td width=16 id="LastClassNode" style="display:none">&nbsp;</td><td>' );
    Htm.Add( '</table>' );
  END;
  Dec( TreeLevel );
end;

procedure SaveHtm( Htm : PStrList; const Path : String );
var Was : PStrList;
    Save : Boolean;
    I : Integer;
    S : String;
begin
  Save := True;
  if FileExists( Path ) then
  begin
    Save := False;
    Was := NewStrList;
    Was.LoadFromFile( Path );
    if Was.Count <> Htm.Count then
       Save := True
    else
    for I := 0 to Htm.Count - 1 do
    begin
      S := Htm.Items[ I ];
      if S = Was.Items[ I ] then continue;
      if IndexOfStr( S, '<font face="Comic' ) >= 1 then continue;
      Save := True;
      break;
    end;
    Was.Free;
  end;
  if Save then Htm.SaveToFile( Path );
end;

procedure AddToGlossary( const Name: String; FromUnit, FromClass : PTopic );
var G, H : PGlossElt;
    I : Integer;
begin
  G := NewGlossElt;
  G.Name := Name;
  G.InUnit := FromUnit;
  G.InClass := FromClass;
  for I := 0 to Glossary.Count - 1 do
  begin
    H := Glossary.Items[ I ];

    if (Name = H.Name) and (FromUnit = H.InUnit) and (FromClass = H.InClass) then
    begin
      G.Free;
      Exit;
    end;

    if (LowerCase( Name ) < LowerCase( H.Name ))
    or (LowerCase( Name ) = LowerCase( H.Name ))
    and ( (FromUnit <> nil) and (H.InUnit <> nil) and (FromUnit.Name < H.InUnit.Name)
        or(FromClass<>nil) and (H.InClass <> nil) and (FromClass.Name < H.InClass.Name) ) then
    begin
      Glossary.Insert( I, G );
      Exit;
    end;

  end;
  Glossary.Add( G );
end;

procedure AddLinesToHtm( Htm : PStrList; Lines : array of String );
var I : Integer;
begin
  for I := Low( Lines ) to High( Lines ) do
      Htm.Add( Lines[ I ] );
end;

function CompareTopics(const TopicList: Pointer; const e1, e2: DWORD): Integer;
var Topic1, Topic2 : PTopic;
begin
  Topic1 := PList(TopicList).Items[ e1 ];
  Topic2 := PList(TopicList).Items[ e2 ];
  Result := 0;
  if Topic1.Name < Topic2.Name then
    Result := -1
  else
  if Topic1.Name > Topic2.Name then
    Result := 1;
end;

procedure SwapTopics(const TopicList: Pointer; const e1, e2: DWORD);
begin
  PList(TopicList).Swap( e1, e2 );
end;

procedure DoProcessMessages;
begin
  Applet.ProcessPendingMessages;
end;

procedure TEventObj.BuildHelp(Sender: PObj);
var I, J, K, N, M : Integer;
    U : PPascalUnit;
    L : PList; // of XTopic for every of unit
    P : TPoint;
    UnitTopic, FoundTopic, Topic, ClassTopic, PrevUnitTopic, PrevClassTopic : PTopic;
    S, S1, FC : String;
    Descr, Htm : PStrList;
    Entry : PEntry;
    TopicType : TTopicType;
    RecClass : PRecordClass;
    Tree : PTree;
    Node : PTree;
    LookFurther : Boolean;
    F : HFile;
    FileTime : TFileTime;
    SysTime : TSystemTime;
    Ini : PIniFile;
    C : Char;
    G, G1 : PGlossElt;
    TmpStrList, Tmp0 : PStrList;
    Sigh : Boolean;
    Pos1, Pos2, PosDiv, PosMul : Integer;
    KK: Integer;
begin
  Button1.Caption := 'Cancel';
  Button1.OnClick := CancelBuild;
  DoProcessMessages;
  L := NewList;
  UnitsList := L;
  Glossary := NewList;
  CustomRefs := NewList;
  for I := 0 to FileList.Count - 1 do
  begin
    Progress1.Progress := (I + 1) * 50 div FileList.Count;
    Label1.Caption := UnitPath( I );
    DoProcessMessages;
    if Cancel then break;
    U := NewPascalUnit;
    S := UnitPath( I );
    U.UnitPath := SourcePath + S;
    P := MakePoint( 0, 0 );
    if StrEq( U.Scan( P ), 'unit' ) then
    begin          // unit<*
      S := U.Scan( P ); // unit Name;<*
      if not StrEq( S + '.pas',
                    ExtractFileName( UnitPath( I ) ) ) then
      begin
        U.Free;
        continue;
      end;
      U.Scan( P );
      S := '';
      for J := P.y + 1 to U.Text.Count - 1 do
      begin
        S := Trim( U.Text.Items[ J ] );
        if Copy( S, 1, 2 ) = '{' + Special then break;
        if Trim( U.CleanText[ J ] ) <> '' then break;
      end;
      if Copy( S, 1, 2 ) = '{' + Special then
      begin
        U.BuildDefinitions;
        Descr := NewStrList;
        Sigh := ScanDescription( Descr, U, P.y + 1 );
        UnitTopic := NewTopic( nil, ttUnit, U.UnitName,
                  'unit ' + U.UnitName, Descr );
        UnitTopic.FUses := NewStrList;
        for KK := 0 to U.Uses1Clause.Count - 1 do
          UnitTopic.FUses.Add( U.Uses1Clause.Items[ KK ] );
        UnitTopic.FSigh := Sigh;
        UnitTopic.FIsChanged := FileList.Items[ I ][ 1 ] = '*';
        L.Add( UnitTopic );
        for J := 0 to U.DeclCount - 1 do
        begin
          if PEntryRecordClass( U.Decls[ J ] ).IsEntry then
          begin
            Entry := PEntry( U.Decls[ J ] );
            S := '';
            for K := Entry.EndPos.y + 1 to U.Text.Count - 1 do
            begin
              S := Trim( U.Text.Items[ K ] );
              if Copy( S, 1, 2 ) = '{' + Special then break;
              //if Trim( U.CleanText[ K ] ) <> '' then break;
              if Entry.EntryType = etMethod then
              begin
                if (K > 0) and (pos( ')', Trim( U.CleanText[ K - 1 ] ) ) > 0) then
                  break;
              end
                else
              begin
                if Trim( U.CleanText[ K ] ) <> '' then break;
              end;
            end;
            if Copy( S, 1, 2 ) = '{' + Special then
            begin
              Descr := NewStrList;
              ScanDescription( Descr, U, Entry.EndPos.y + 1 );
              TopicType := Low( TopicType );
              case Entry.EntryType of
              etField:  TopicType := ttField;
              etMethod: TopicType := ttMethod;
              etType:   TopicType := ttType;
              etConst:  TopicType := ttConst;
              else S := '';
              end;
              if S <> '' then
              begin
                S := ScanDefinition( U, Entry.StartPos, Entry.EndPos );
                NewTopic( UnitTopic, TopicType, Entry.Name,
                     S, Descr );
              end else Descr.Free;
            end;
          end
             else
          begin
            RecClass := PRecordClass( U.Decls[ J ] );
            S := '';
            for K := RecClass.DefBodyStart.y + 1 to U.Text.Count - 1 do
            begin
              S := Trim( U.Text.Items[ K ] );
              if Copy( S, 1, 2 ) = '{' + Special then break;
              if Trim( U.CleanText[ K ] ) <> '' then break;
              //if (K > 0) and (pos( ')', Trim( U.CleanText[ K - 1 ] ) ) > 0) then
              //  break;
            end;
            if Copy( S, 1, 2 ) <> '{' + Special then continue;
            if RecClass.EntryCount = 0 then continue;
            S := U.CleanText[ RecClass.DefStart.y ];
            if not StrEq( CopyTail( S, 6 ), 'record' ) then continue;
            S := ScanDefinition( U, RecClass.DefStart, RecClass.Entries[ 0 ].StartPos );
            Descr := NewStrList;
            ScanDescription( Descr, U, RecClass.DefBodyStart.y + 1 );
            ClassTopic := NewTopic( UnitTopic, ttRecord, RecClass.Name, S, Descr );
            ClassTopic.FRecDef := NewStrList;
            ClassTopic.FRecCln := NewStrList;
            for K := RecClass.Entries[ 0 ].StartPos.y to RecClass.DefEnd.y - 1 do
            begin
              ClassTopic.FRecDef.Add( U.Text.Items[ K ] );
              ClassTopic.FRecCln.Add( U.CleanText[ K ] );
            end;
            ClassTopic.Ancestor := ''; //RecClass.Ancestor;
            FillSubtopics( ClassTopic, RecClass, U );
            S := '';
            for K := RecClass.DefEnd.y + 1 to U.Text.Count - 1 do
            begin
              S := Trim( U.Text.Items[ K ] );
              if Copy( S, 1, 2 ) = '{' + Special then break;
              if Trim( U.CleanText[ K ] ) <> '' then break;
              //if (K > 0) and (pos( ')', Trim( U.CleanText[ K - 1 ] ) ) > 0) then
              //  break;
            end;
            if Copy( S, 1, 2 ) <> '{' + Special then continue;
            ScanDescription( ClassTopic.Tasks, U, RecClass.DefEnd.y + 1 );
          end;
        end;
        for J := 0 to U.DeclCount - 1 do
        if not PEntryRecordClass( U.Decls[ J ] ).IsEntry then
        begin
          RecClass := PRecordClass( U.Decls[ J ] );
          S := '';
          for K := RecClass.DefBodyStart.y + 1 to U.Text.Count - 1 do
          begin
            S := Trim( U.Text.Items[ K ] );
            if Copy( S, 1, 2 ) = '{' + Special then break;
            if Trim( U.CleanText[ K ] ) <> '' then break;
            //if (K > 0) and (pos( ')', Trim( U.CleanText[ K - 1 ] ) ) > 0) then
            //  break;
          end;
          if Copy( S, 1, 2 ) <> '{' + Special then continue;
          if RecClass.EntryCount = 0 then continue;
          S := ScanDefinition( U, RecClass.DefStart, RecClass.Entries[ 0 ].StartPos );
          if (IndexOfStr( S, 'class' ) <= 0) and
             (IndexOfStr( S, 'object' ) <= 0) and
             (IndexOfStr( S, 'interface' ) <= 0) then continue;
          Descr := NewStrList;
          Sigh := ScanDescription( Descr, U, RecClass.DefBodyStart.y + 1 );
          ClassTopic := NewTopic( UnitTopic, ttClass, RecClass.Name, S, Descr );
          ClassTopic.FSigh := Sigh;
          ClassTopic.Ancestor := RecClass.Ancestor;
          FillSubtopics( ClassTopic, RecClass, U );
          S := '';
          for K := RecClass.DefEnd.y + 1 to U.Text.Count - 1 do
          begin
            S := Trim( U.Text.Items[ K ] );
            if Copy( S, 1, 2 ) = '{' + Special then break;
            if Trim( U.CleanText[ K ] ) <> '' then break;
            //if (K > 0) and (pos( ')', Trim( U.CleanText[ K - 1 ] ) ) > 0) then
            //  break;
          end;
          if Copy( S, 1, 2 ) <> '{' + Special then continue;
          ScanDescription( ClassTopic.Tasks, U, RecClass.DefEnd.y + 1 );
        end;
      end;
    end;
    U.Free;
  end;

  // Order units
  PrevUnitTopic := nil;
  for I := 0 to L.Count - 1 do
  begin
    FoundTopic := nil; M := L.Count;
    for J := 0 to L.Count - 1 do
    begin
      UnitTopic := L.Items[ J ];
      if UnitTopic.FHandled then continue;
      N := 0;
      for K := 0 to UnitTopic.FUses.Count - 1 do
      begin
        Topic := UnitTopicByName( UnitTopic.Fuses.Items[ K ] );
        if Topic = nil then continue;
        if Topic.FHandled then continue;
        Inc( N );
      end;
      if (FoundTopic = nil) or (N < M) then
      begin
        FoundTopic := UnitTopic;
        M := N;
      end;
    end;
    if FoundTopic = nil then break;
    FoundTopic.FHandled := True;
    if PrevUnitTopic <> nil then
    begin
      PrevUnitTopic.FNext := FoundTopic;
      FoundTopic.FPrev := PrevUnitTopic;
    end;
    PrevUnitTopic := FoundTopic;
  end;

  // Build class tree
  Tree := NewTree( nil, '' );
  PrevClassTopic := nil;
  for I := 0 to UnitsList.Count - 1 do
  begin
    UnitTopic := UnitsList.Items[ I ];
    for J := 0 to UnitTopic.TopicsCount - 1 do
    begin
      Topic := UnitTopic.Topics[ J ];
      Topic.FHandled := False;
      if Topic.TopicType = ttClass then
      begin
        ClassTopic := nil;
        if Topic.Ancestor <> '' then
           ClassTopic := ClassTopicByName( Topic.Ancestor );
        if ClassTopic = nil then
        begin
          Node := NewTree( Tree, Topic.Name );
          Node.Data := Topic;
          Topic.FHandled := True;
          Topic.FNode := Node;
          if PrevClassTopic <> nil then
          begin
            PrevClassTopic.FNext := Topic;
            Topic.FPrev := PrevClassTopic;
          end;
          PrevClassTopic := Topic;
        end;
      end;
    end;
  end;

  LookFurther := True;
  while LookFurther do
  begin
    LookFurther := False;
    for I := 0 to UnitsList.Count - 1 do
    begin
      UnitTopic := UnitsList.Items[ I ];
      for J := 0 to UnitTopic.TopicsCount - 1 do
      begin
        Topic := UnitTopic.Topics[ J ];
        if (Topic.TopicType = ttClass) and (not Topic.FHandled)
        and (Topic.Ancestor <> '') then
        begin
          ClassTopic := ClassTopicByName( Topic.Ancestor );
          if (ClassTopic = nil) or (ClassTopic.FNode = nil) then
             LookFurther := True
          else
          begin
            Node := NewTree( ClassTopic.FNode, Topic.Name );
            Node.Data := Topic;
            Topic.FHandled := True;
            Topic.FNode := Node;
            if PrevClassTopic <> nil then
            begin
              PrevClassTopic.FNext := Topic;
              Topic.FPrev := PrevClassTopic;
            end;
            PrevClassTopic := Topic;
          end;
        end;
      end;
    end;
  end;

  if not Cancel then
  for I := 0 to L.Count - 1 do
  begin
    UnitTopic := L.Items[ I ];

    AddToGlossary( UnitTopic.Name, UnitTopic, nil );

    CurrentUnit := UnitTopic;

    Pos1 := Progress1.Progress;
    Pos2 := 50 + (I + 1) * 50 div L.Count;
    PosDiv := 1;
    for J := 0 to UnitTopic.TopicsCount - 1 do
    begin
      Topic := UnitTopic.Topics[ J ];
      if Topic.TopicType = ttClass then
         Inc( PosDiv );
    end;
    Progress1.Progress := Pos1 + (Pos2 - Pos1) div PosDiv;
    PosMul := 1;

    Label1.Caption := CurrentUnit.Name + '.pas';
    DoProcessMessages;
    if Cancel then break;

    IF (not StrIn( Param, [ '-IndexOnly', '-io' ] ))
       and UnitTopic.IsChanged then
    BEGIN

    // Create unit topic
    GeneratingUnit := True;
    MacroList := UnitTopic.FMacroList;
    Htm := NewStrList;

    Htm.Add( '<html>' );
    Htm.Add( '' );
    Htm.Add( '<head>' );
    Htm.Add( '<title>' + TitleString + ': unit ' + UnitTopic.Name + '.pas</title>' );
    Htm.Add( '</head>' );
    Htm.Add( '' );
    Htm.Add( '<body bgcolor="#' + BgColor + '" text="#' + TxColor + '" link="#' + CLink +'" vlink="#' + VLink + '" alink="#' + ALink + '">' );
    Htm.Add( '' );
    Htm.Add( '<h1 align="center">' );
    if UnitTopic.FPrev <> nil then
    begin
      if UseWebdings then
        Htm.Add( '&nbsp;&nbsp;<a href="' + UnitTopic.FPrev.HtName +
                 '"><font face="Webdings" size=7>&#55;</font></a>&nbsp;&nbsp;' )
      else
        Htm.Add( '<a href="' + UnitTopic.Fprev.HtName + '"><img src=prev.gif border=0 title="' +
                 UnitTopic.FPrev.Name + '.pas unit" align=left></a>' );
    end;
    if UnitTopic.FNext <> nil then
    begin
      if UseWebdings then
        Htm.Add( '&nbsp;&nbsp;<a href="' + UnitTopic.FNext.HtName +
                 '"><font face="Webdings" size=7>&#56;</font></a>&nbsp;&nbsp;' )
      else
        Htm.Add( '<a href="' + UnitTopic.FNext.HtName + '"><img src=next.gif border=0 title="' +
                 UnitTopic.FNext.Name + '.pas unit" align=right></a>' );
    end;
    Htm.Add( '<font face="Arial" color="#' + HdColor + '">unit ' + UnitTopic.Name + '.pas</font>' );
    Htm.Add( '</h1>' );
    Htm.Add( '<hr>' );
    Htm.Add( '<p>' );
    AddTextToHtm( Htm, UnitTopic.Description, UnitTopic.FDescrText );
    Htm.Add( '</p>' );

    if UnitTopic.TopicsCount > 0 then
      Htm.Add( '<h2 align="center"><font face="Arial" color="#' + HdColor + '">Content</font></h2>' );

    for J := 0 to UnitTopic.TopicsCount - 1 do
    begin
      Topic := UnitTopic.Topics[ J ];
      S := Topic.Definition;
      if Topic.TopicType in [ ttClass, ttRecord, ttType ] then
         S := 'type ' + Topic.Definition
      else
      if Topic.TopicType = ttField then
         S := 'var ' + Topic.Definition
      else
      if Topic.TopicType = ttConst then
         S := 'const ' + Topic.Definition;
      FC := '';
      if Topic.TopicType = ttClass then
      begin
         CurrentClass := Topic;
         FC := ColorClass;
      end
         else
      begin
        CurrentTopic := Topic;
      end;
      AddToGlossary( Topic.Name, UnitTopic, nil );
      Htm.Add( '<a name="' + LowerCase( Topic.Name ) + '"></a>' );
      if Topic.TopicType = ttClass then
      begin
        S1 := LowerCase( Topic.Name );
        if FileExists( ResultPath + S1 + '.gif' ) then
           Htm.Add( '<a href=' + Topic.HtName + '><img src="' + S1 + '.gif" border=0 align=left></a>' )
        else
        if FileExists( ResultPath + S1 + '.jpg' ) then
           Htm.Add( '<a href=' + Topic.HtName + '><img src="' + S1 + '.jpg" border=0 align=left></a>' );
      end;
      Htm.Add( '<p>' );
      AddDefToHtm( Htm, S, Topic, FC );
      Htm.Add( '<br>' );
      AddTextToHtm( Htm, Topic.Description, Topic.FDescrText );
      if Topic.TopicType = ttRecord then
      begin
        Htm.Add( '<table border="0" cellpadding="0" cellspacing="0" width="100%">' );
        for K := 0 to Topic.FRecDef.Count - 1 do
        begin
          S := Trim( Topic.FRecCln.Items[ K ] );
          if S = '' then continue;
          Htm.Add( '  <tr>' );
          Htm.Add( '    <td width="32">&nbsp;</td>' );
          Htm.Add( '    <td valign="top">' );
          AddDefToHtm( Htm, '  ' + S, Topic, ColorName );
          Htm.Add( '    </td>' );
          Htm.Add( '    <td valign="top">' );
          S := Trim( Topic.FRecDef.Items[ K ] );
          M := 0;
          if S <> Trim( Topic.FRecCln.Items[ K ] ) then
          begin
            M := IndexOfStr( S, '//' );
            if M > 0 then
            begin
              S := Trim( CopyEnd( S, M + 2 ) );
              TmpStrList := NewStrList;
              TmpStrList.Add( S );
              Tmp0 := nil;
              AddTextToHtm( Htm, TmpStrList, Tmp0 );
              TmpStrList.Free;
              Tmp0.Free;
            end;
          end;
          if K < Topic.FRecDef.Count - 1 then
          begin
            S := Trim( Topic.FRecDef.Items[ K + 1 ] );
            if Copy( S, 1, 2 ) = '{' + Special then
            begin
              TmpStrList := NewStrList;
              Tmp0 := nil;
              ScanDescriptionFromStrings( TmpStrList, Topic.FRecDef, K + 1 );
              if M = 0 then
              begin
                AddTextToHtm( Htm, TmpStrList, Tmp0 );
              end
                 else
              begin
                Htm.Add( '</td></tr><tr><td width="32">&nbsp;</td>' );
                Htm.Add( '<td colspan=2 valign=top>' );
                AddTextToHtm( Htm, TmpStrList, Tmp0 );
              end;
              TmpStrList.Free;
              Tmp0.Free;
            end;
          end;
          Htm.Add( '    </td>' );
          Htm.Add( '  </tr>' );
        end;
        Htm.Add( '</table>' );
        Tmp0 := nil;
        if Topic.FTasks <> nil then
           AddTextToHtm( Htm, Topic.FTasks, Tmp0 );
        Tmp0.Free;
        AddDefToHtm( Htm, 'end;', nil, ColorName );
      end;
      Htm.Add( '</p>' );
      CurrentClass := nil;
      CurrentTopic := nil;
    end;

    Htm.Add( '<hr>' );
    Htm.Add( '<p align="center">[&nbsp;<a href=index.htm>Index</a>&nbsp;]</p>' );
    Htm.Add( '<p align="center"><font face="Comic Sans MS"><small>This help is generated ' +
                 Int2Str( FTime.wDay ) + '-' + Months[ FTime.wMonth ] + '-' +
                 Int2Str( FTime.wYear ) + cVK_BAP);
    Htm.Add( '</body>' );
    Htm.Add( '</html>' );
    SaveHtm( Htm, ResultPath + UnitTopic.HtName );
    Htm.Free;

    GeneratingUnit := False;
    END;

    for J := 0 to UnitTopic.TopicsCount - 1 do
    begin
      DoProcessMessages;

      if Cancel then break;

      Topic := UnitTopic.Topics[ J ];
      if Topic.TopicType = ttClass then
      begin
        CurrentClass := Topic;

        Inc( PosMul );
        Progress1.Progress := Pos1 + (Pos2 - Pos1) * PosMul div PosDiv;
        Label1.Caption := UnitTopic.Name + '.pas - ' + CurrentClass.Name;
        DoProcessMessages;
        if Cancel then break;

        AddToGlossary( Topic.Name, UnitTopic, Topic );
        for K := 0 to Topic.TopicsCount - 1 do
        begin
          Foundtopic := Topic.Topics[ K ];
          AddToGlossary( FoundTopic.Name, UnitTopic, Topic );
        end;

        IF (not StrIn( Param, [ '-IndexOnly', '-io' ] ))
        and UnitTopic.IsChanged then
        BEGIN

        // Generate frames page
        Htm := NewStrList;
        Htm.Add( '<html>' );
        Htm.Add( '<head>' );

        if IndexOfStr( LowerCase(Topic.Definition), 'class' ) >= 0 then
          Htm.Add( '<title>' + TitleString + ': ' + Topic.Name + ' class</title>' )
        else
        if IndexOfStr( LowerCase(Topic.Definition), 'object' ) >= 0 then
          Htm.Add( '<title>' + TitleString + ': ' + Topic.Name + ' object</title>' )
        else
        if IndexOfStr( LowerCase(Topic.Definition), 'interface' ) >= 0 then
          Htm.Add( '<title>' + TitleString + ': ' + Topic.Name + ' interface</title>' );

        Htm.Add( '<script language="JavaScript">' );
        Htm.Add( 'function Loaded()' );
        Htm.Add( '{' );
        //Htm.Add( 'alert( location.hash );' );
        Htm.Add( 'if(location.hash!="")' );
        Htm.Add( '  frames["main"].location.hash=location.hash;' );
        Htm.Add( '}' );
        Htm.Add( '</script>' );

        Htm.Add( '</head>' );

        Htm.Add( '<frameset rows="64,*" border="false" frameborder="0" onLoad="Loaded();">' );
        Htm.Add( '  <frame name="top" scrolling="no" noresize target="left" src="top_' +
                 Topic.HtName + '">' );
        Htm.Add( '  <frameset cols="150,*" border="false" frameborder="0">' );
        Htm.Add( '    <frame name="left" target="main" src="left_' + Topic.HtName +
                 '" scrolling="auto" noresize>' );
        Htm.Add( '    <frame name="main" src="main_' + Topic.HtName + '" scrolling="auto">' );
        Htm.Add( '  </frameset>' );
        Htm.Add( '  <noframes>' );
        Htm.Add( '  <body>' );
        Htm.Add( '  <p>This page uses frames, but your browser doesn''t support them.</p>' );
        Htm.Add( '  </body>' );
        Htm.Add( '  </noframes>' );
        Htm.Add( '</frameset>' );
        Htm.Add( '</html>' );

        SaveHtm( Htm, ResultPath + Topic.HtName );
        Htm.Free;

        // Generate top page
        Htm := NewStrList;
        Htm.Add( '<html>' );
        Htm.Add( '<head>' );

        if IndexOfStr( LowerCase(Topic.Definition), 'class' ) >= 0 then
          Htm.Add( '<title>' + TitleString + ': ' + Topic.Name + ' class (top frame)</title>' )
        else
        if IndexOfStr( LowerCase(Topic.Definition), 'object' ) >= 0 then
          Htm.Add( '<title>' + TitleString + ': ' + Topic.Name + ' object (top frame)</title>' )
        else
        if IndexOfStr( LowerCase(Topic.Definition), 'interface' ) >= 0 then
          Htm.Add( '<title>' + TitleString + ': ' + Topic.Name + ' interface (top frame)</title>' );

        Htm.Add( '<base target="left">' );
        Htm.Add( '</head>' );
        Htm.Add( '' );
        Htm.Add( '<body bgcolor="#' + BgColor + '" text="#' + TxColor + '" link="#' + CLink +'" vlink="#' + VLink + '" alink="#' + ALink + '">' );
        Htm.Add( '<div style="position: absolute; left: 10; top: 6; width: 100%">' );
        Htm.Add( '<table border=0 width="100%"><tr>' );
        if Topic.FPrev <> nil then
          if IndexOfStr( LowerCase(Topic.Definition), 'class' ) >= 0 then
          begin
            if UseWebdings then
              Htm.Add( '<td valign=top>&nbsp;&nbsp;&nbsp;<a href="' + Topic.Fprev.HtName + '" target="_top">' +
                       '<font face="Webdings" size=7>&#55;</font></a>&nbsp;&nbsp;&nbsp;</td>' )
            else
              Htm.Add( '<td valign=top><a href="' + Topic.Fprev.HtName + '" target="_top"><img src=prev.gif border=0 title="' +
                     Topic.FPrev.Name + ' class"></a></td>' )
          end
            else
          if IndexOfStr( LowerCase(Topic.Definition), 'object' ) >= 0 then
          begin
            if UseWebdings then
              Htm.Add( '<td valign=top>&nbsp;&nbsp;&nbsp;<a href="' + Topic.Fprev.HtName + '" target="_top">' +
                       '<font face="Webdings" size=7>&#55;</font></a>&nbsp;&nbsp;&nbsp;</td>' )
            else
              Htm.Add( '<td valign=top><a href="' + Topic.Fprev.HtName + '" target="_top"><img src=prev.gif border=0 title="' +
                     Topic.FPrev.Name + ' object"></a></td>' )
          end
            else
          if IndexOfStr( LowerCase(Topic.Definition), 'interface' ) >= 0 then
          begin
            if UseWebdings then
              Htm.Add( '<td valign=top>&nbsp;&nbsp;&nbsp;<a href="' + Topic.Fprev.HtName + '" target="_top">' +
                       '<font face="Webdings" size=7>&#55;</font></a>&nbsp;&nbsp;&nbsp;</td>' )
            else
              Htm.Add( '<td valign=top><a href="' + Topic.Fprev.HtName + '" target="_top"><img src=prev.gif border=0 title="' +
                     Topic.FPrev.Name + ' interface"></a></td>' );
          end;

        Htm.Add( '<td valign=top>' );

        S1 := LowerCase( Topic.Name );
        if FileExists( ResultPath + S1 + '.jpg' ) then
           Htm.Add( '<img src="' + S1 + '.jpg" border=0 align=absmiddle></td><td valign=top>' )
        else
        if FileExists( ResultPath + S1 + '.gif' ) then
           Htm.Add( '<img src="' + S1 + '.gif" border=0 align=absmiddle></td><td valign=top>' );

        if IndexOfStr( LowerCase(Topic.Definition), 'class' ) >= 0 then
          Htm.Add( '<p align="center"><font size=6 face="Arial" color="#' + HdColor + '"><b>' + Topic.Name +
                 ' class</b></font><br>' )
        else
        if IndexOfStr( LowerCase(Topic.Definition), 'object' ) >= 0 then
          Htm.Add( '<p align="center"><font size=6 face="Arial" color="#' + HdColor + '"><b>' + Topic.Name +
                 ' object</b></font><br>' )
        else
        if IndexOfStr( LowerCase(Topic.Definition), 'interface' ) >= 0 then
          Htm.Add( '<p align="center"><font size=6 face="Arial" color="#' + HdColor + '"><b>' + Topic.Name +
                 ' interface</b></font><br>' );

        if PropCount( Topic, True ) > 0 then
          Htm.Add( '[&nbsp;<a href=left_' + Topic.HtName + '#props>Properties</a>&nbsp;]' );
        if MethodCount( Topic, True ) > 0 then
          Htm.Add( '[&nbsp;<a href=left_' + Topic.HtName + '#methods>Methods</a>&nbsp;]' );
        if EventCount( Topic, True ) > 0 then
          Htm.Add( '[&nbsp;<a href=left_' + Topic.HtName + '#events>Events</a>&nbsp;]' );
        if FieldCount( Topic, True ) > 0 then
          Htm.Add( '[&nbsp;<a href=left_' + Topic.HtName + '#fields>Fields</a>&nbsp;]' );
        if Topic.Tasks.Count > 0 then
          Htm.Add( '[&nbsp;<a href=main_' + Topic.HtName + '#tasks target=main>Tasks</a>&nbsp;]' );
        Htm.Add( ' &nbsp;&nbsp;&nbsp;[&nbsp;<a href=index.htm target="_top">Index</a>&nbsp;]' );
        Htm.Add( '</p></td>' );

        if Topic.FNext <> nil then
          if IndexOfStr( LowerCase(Topic.Definition), 'class' ) >= 0 then
          begin
            if UseWebdings then
              Htm.Add( '<td valign=top>&nbsp;&nbsp;&nbsp;<a href="' + Topic.FNext.HtName + '" target="_top">' +
                       '<font face="Webdings" size=7>&#56;</font></a>&nbsp;&nbsp;&nbsp;</td>' )
            else
              Htm.Add( '<td valign=top><a href="' + Topic.FNext.HtName + '" target="_top"><img src=next.gif border=0 title="' +
                     Topic.FNext.Name + ' class" align=right></a></td>' )
          end
            else
          if IndexOfStr( LowerCase(Topic.Definition), 'object' ) >= 0 then
          begin
            if UseWebdings then
              Htm.Add( '<td valign=top>&nbsp;&nbsp;&nbsp;<a href="' + Topic.FNext.HtName + '" target="_top">' +
                       '<font face="Webdings" size=7>&#56;</font></a>&nbsp;&nbsp;&nbsp;</td>' )
            else
              Htm.Add( '<td valign=top><a href="' + Topic.FNext.HtName + '" target="_top"><img src=next.gif border=0 title="' +
                     Topic.FNext.Name + ' object" align=right></a></td>' )
          end
            else
          if IndexOfStr( LowerCase(Topic.Definition), 'interface' ) >= 0 then
          begin
            if UseWebdings then
              Htm.Add( '<td valign=top>&nbsp;&nbsp;&nbsp;<a href="' + Topic.FNext.HtName + '" target="_top">' +
                       '<font face="Webdings" size=7>&#56;</font></a>&nbsp;&nbsp;&nbsp;</td>' )
            else
              Htm.Add( '<td valign=top><a href="' + Topic.FNext.HtName + '" target="_top"><img src=next.gif border=0 title="' +
                   Topic.FNext.Name + ' interface" align=right></a></td>' );
          end;

        Htm.Add( '</tr></table>' );
        Htm.Add( '</div>' );
        Htm.Add( '</body>' );
        Htm.Add( '</html>' );
        SaveHtm( Htm, ResultPath + 'top_' + Topic.HtName );
        Htm.Free;

        // Generate left page
        Htm := NewStrList;
        Htm.Add( '<html>' );
        Htm.Add( '<head>' );
        if IndexOfStr( LowerCase(Topic.Definition), 'class' ) >= 0 then
          Htm.Add( '<title>' + TitleString + ': ' + Topic.Name + ' class (left frame)</title>' )
        else
       if IndexOfStr( LowerCase(Topic.Definition), 'object' ) >= 0 then
          Htm.Add( '<title>' + TitleString + ': ' + Topic.Name + ' object (left frame)</title>' )
        else
       if IndexOfStr( LowerCase(Topic.Definition), 'interface' ) >= 0 then
          Htm.Add( '<title>' + TitleString + ': ' + Topic.Name + ' interface (left frame)</title>' );
        Htm.Add( '<base target="main">' );
        Htm.Add( '</head>' );
        Htm.Add( '' );
        Htm.Add( '<body bgcolor="#' + BgColor + '" text="#' + HdColor + '" link="#' + CLink +'" vlink="#' + VLink + '" alink="#' + ALink + '">' );
        Htm.Add( '<p align="center">' + Topic.Name + ' reference</p>' );
        if PropCount( Topic, True ) > 0 then
        begin
          Htm.Add( '<a name=props></a><p><b>' + Topic.Name + ' properties</b></p>' );
          AddRefsToLeftHtm( Htm, Topic, ttProperty, False );
        end;
        if MethodCount( Topic, True ) > 0 then
        begin
          Htm.Add( '<a name=methods></a><p><b>' + Topic.Name + ' methods</b></p>' );
          AddRefsToLeftHtm( Htm, Topic, ttMethod, False );
        end;
        if EventCount( Topic, True ) > 0 then
        begin
          Htm.Add( '<a name=events></a><p><b>' + Topic.Name + ' events</b></p>' );
          AddRefsToLeftHtm( Htm, Topic, ttProperty, True );
        end;
        if FieldCount( Topic, True ) > 0 then
        begin
          Htm.Add( '<a name=fields></a><p><b>' + Topic.Name + ' fields</b></p>' );
          AddRefsToLeftHtm( Htm, Topic, ttField, False );
        end;
        Htm.Add( '</body>' );
        Htm.Add( '</html>' );
        SaveHtm( Htm, ResultPath + 'left_' + Topic.HtName );
        Htm.Free;

        // Generate main page
        Htm := NewStrList;
        Htm.Add( '<html>' );
        Htm.Add( '<head>' );
        if IndexOfStr( LowerCase(Topic.Definition), 'class' ) >= 0 then
          Htm.Add( '<title>' + TitleString + ': ' + Topic.Name + ' class (main frame)</title>' )
        else
        if IndexOfStr( LowerCase(Topic.Definition), 'object' ) >= 0 then
          Htm.Add( '<title>' + TitleString + ': ' + Topic.Name + ' object (main frame)</title>' )
        else
        if IndexOfStr( LowerCase(Topic.Definition), 'interface' ) >= 0 then
          Htm.Add( '<title>' + TitleString + ': ' + Topic.Name + ' interface (main frame)</title>' );
        Htm.Add( '<base target="_top">' );
        Htm.Add( '</head>' );
        Htm.Add( '' );
        Htm.Add( '<body bgcolor="#' + BgColor + '" text="#' + TxColor + '" link="#' + CLink +'" vlink="#' + VLink + '" alink="#' + ALink + '">' );
        if Topic.Ancestor <> '' then
        begin
          Htm.Add( '<p><font face="Courier" color="#' + ColorName + '"><b>' + Topic.Name + '( unit <a href=' + UnitTopic.HtName +
                   '>' + UnitTopic.Name + '.pas</a> )' );
          ClassTopic := Topic;
          while (ClassTopic <> nil) and (ClassTopic.Ancestor <> '') do
          begin
            S := IsClass( '', ClassTopic.Ancestor );
            if S = '' then
              S := ClassTopic.Ancestor
            else
              S := '<a href=' + S + '>' + ClassTopic.Ancestor + '</a>';
            Htm.Add( ' <font face="Wingdings"></font> ' + S );
            ClassTopic := ClassTopicByName( ClassTopic.Ancestor );
          end;
          Htm.Add( '</b></font></p>' );
        end
          else
        begin
          Htm.Add( '<p><font face="Courier" color="#' + ColorName + '"><b>' + Topic.Name + '( unit <a href=' + UnitTopic.HtName +
                   '>' + UnitTopic.Name + '.pas</a> )</b></font></p>' );
        end;
        Htm.Add( '<p><b>' );
        Tmp0 := NewStrList;
        Tmp0.Add( Topic.Definition );
        AddTextToHtm( Htm, Tmp0, nil );
        Tmp0.Free;
        Htm.Add( '</b></p>' );

        AddTextToHtm( Htm, Topic.Description, Topic.FDescrText );
        if PropCount( Topic, True ) > 0 then
        begin
          Htm.Add( '<h3 align="center"><font color="#' + HdColor + '">' + Topic.Name + ' properties</font></h3>' );
          AddDefsToClassHtm( Htm, Topic, ttProperty, False );
        end;
        if MethodCount( Topic, True ) > 0 then
        begin
          Htm.Add( '<h3 align="center"><font color="#' + HdColor + '">' + Topic.Name + ' methods</font></h3>' );
          AddDefsToClassHtm( Htm, Topic, ttMethod, False );
        end;
        if EventCount( Topic, True ) > 0 then
        begin
          Htm.Add( '<h3 align="center"><font color="#' + HdColor + '">' + Topic.Name + ' events</font></h3>' );
          AddDefsToClassHtm( Htm, Topic, ttProperty, True );
        end;
        if FieldCount( Topic, True ) > 0 then
        begin
          Htm.Add( '<h3 align="center"><font color="#' + HdColor + '">' + Topic.Name + ' fields</font></h3>' );
          AddDefsToClassHtm( Htm, Topic, ttField, False );
        end;
        if Topic.Tasks.Count > 0 then
        begin
          Htm.Add( '<a name=tasks></a><h3 align="center"><font color="#' + HdColor + '">' + Topic.Name + ' tasks</font></h3>' );
          Tmp0 := nil;
          AddTextToHtm( Htm, Topic.Tasks, Tmp0 );
          Tmp0.Free;
        end;
        Htm.Add( '<hr>' );
        Htm.Add( '<p align="center">[&nbsp;<a href=index.htm>Index</a>&nbsp;]</p>' );
        Htm.Add( '<p align="center"><font face="Comic Sans MS"><small>This help is generated ' +
                 Int2Str( FTime.wDay ) + '-' + Months[ FTime.wMonth ] + '-' +
                 Int2Str( FTime.wYear ) + cVK_BAP);
        Htm.Add( '</body>' );
        Htm.Add( '</html>' );
        SaveHtm( Htm, ResultPath + 'main_' + Topic.HtName );
        Htm.Free;

        END;

        CurrentClass := nil;
      end;
    end;

    CurrentUnit := nil;
  end;

  if not Cancel then
  BEGIN

  Htm := NewStrList;
  Htm.Add( '<html>' );
  Htm.Add( '' );
  Htm.Add( '<head>' );
  Htm.Add( '<title> ' + TitleString + ': INDEX </title>' );
  if DynamicTree then
  begin
    AddLinesToHtm( Htm, [
'<script language="JavaScript">',
'  var ClassTreeState = 0;',
'  var ViewUnitsSorted = 0;',
'  var ViewClassSorted = 0;',
'function getCtlTag(src)',
'{',
'  TRok = false',
'  while("HTML" != src.tagName)',
'  {',
'    if("IMG" == src.tagName || "FONT" == src.tagName || "A" == src.tagName)',
'      TRok = true',
'    if("LI" == src.tagName)',
'      return src',
'    if("TR" == src.tagName)',
'    {',
'      if(TRok)',
'        return src',
'      return null',
'    }',
'    src = src.parentElement',
'  }',
'  return null',
'}',
'function dynOutlineEnabled(src)',
'{',
'  while ("HTML" != src.tagName)',
'  {',
'    if("UL" == src.tagName || "TABLE" == src.tagName)',
'      if(null != src.getAttribute("dynoutline", false))',
'        return true',
'    src = src.parentElement',
'  }',
'  return false',
'}',
'function containedIn(src, dst)',
'{',
'  var lev = 1;',
'  while("HTML" != src.tagName)',
'  {',
'     if(src == dst)',
'       return true',
'    if("TABLE" == src.tagName)',
'      lev--',
'    src = src.parentElement',
'    if(lev <= 0)',
'      return false',
'  }',
'  return false',
'}',
'function doExpandCollapse(src, disp)',
'{',
'  var idx = src.sourceIndex+1',
'  while(idx < document.all.length && containedIn(document.all[idx].parentElement, src))',
'  {',
'    srcTmp = document.all[idx]',
'    tag = srcTmp.tagName',
'    if ("UL" == tag || "TABLE" == tag)',
'    {',
'      if(disp == "?")',
'	   disp = srcTmp.style.display',
' 	if( disp == "" )',
'      {',
'        if(srcTmp.style.display == "")',
'        {',
'          srcTmp.style.display = "none"',
'          doExpandCollapse( srcTmp, "" )',
'        }',
'      }',
'	 else',
'      {',
'	 if(srcTmp.style.display != "")',
'         srcTmp.style.display = ""',
'	}',
'    }',
'    idx++;',
'  }',
'}',
'function doOutline()',
'{',
'  var ms = navigator.appVersion.indexOf("MSIE");',
'  ie4 = (ms>0) && (parseInt(navigator.appVersion.substring(ms+5, ms+6)) >= 4);',
'  if(!ie4)',
'     return;',
'  var src = event.srcElement',
'  src = getCtlTag(src)',
'  if (null == src)',
'     return;',
'  if(!dynOutlineEnabled(src))',
'    return;',
'  doExpandCollapse( src, "?" );',
'  ClassTreeState = 0',
'}',
'function ShowByNames()',
'{',
'  document.all[ "ByDependances" ].style.display = "none";',
'  document.all[ "ByNames" ].style.display = "";',
'  ViewUnitsSorted = 1;',
'}',
'function ShowByDependances()',
'{',
'  document.all[ "ByDependances" ].style.display = "";',
'  document.all[ "ByNames" ].style.display = "none";',
'  ViewUnitsSorted = 0;',
'}',
'function SortClasses()',
'{',
'  document.all[ "ClassesByName" ].style.display = "";',
'  document.all[ "ClassTree" ].style.display = "none";',
'  ViewClassSorted = 1;',
'}',
'function ShowClassTree()',
'{',
'  document.all[ "ClassesByName" ].style.display = "none";',
'  document.all[ "ClassTree" ].style.display = "";',
'  ViewClassSorted = 0;',
'}',
'function ExpandCollapseAll()',
'{',
'  last = document.all[ "LastClassNode"].sourceIndex;',
'  for( i=document.all[ "FirstClassNode" ].sourceIndex;i<last;i++ )',
'  {',
'    src = document.all[ i ];',
'    tag = src.tagName',
'    if("TABLE"==tag)',
'    {',
'      if(ClassTreeState!=1)',
'      {',
'        document.all[ i ].style.display="";',
'      }',
'      else',
'      {',
'        document.all[ i ].style.display="none";',
'      }',
'    }',
'  }',
'  if(ClassTreeState==1)',
'    ClassTreeState=2',
'  else',
'    ClassTreeState=1;',
'}',
'function SaveState()',
'{',
'  dt = new Date(199,0,1);',
'  ck = ClassTreeState + 10 * ViewUnitsSorted + 100 * ViewClassSorted;',
'  document.cookie = "state=" + ck + "; " + dt.toGMTString();',
'}',
'function RestoreState()',
'{',
'  ck = document.cookie;',
'  i = ck.indexOf( "=" );',
'  if(i>0)',
'  {',
'    ck = ck.substring( i+1 );',
'    i = ck.indexOf( ";" );',
'    if(i>0)',
'      ck = ck.substring( 0, i );',
'    if( ck >= 100 )',
'      SortClasses();',
'    ck = ck % 100;',  
'    if( ck >= 10 )',
'      ShowByNames();',
'    ck = ck % 10;',
'    while(ck!=ClassTreeState)',
'    {',
'      ExpandCollapseAll();',
'      if(!ck)',
'        break;',
'    }',
'  }',
'}',
'</script>'
] );
  end;

  Htm.Add( '</head>' );
  Htm.Add( '' );
    Htm.Add( '<body bgcolor="#' + BgColor +'" text="#' + TxColor + '" link="#' + CLink +
             '" vlink="#' + VLink + '" alink="#' + ALink +
             '" onUnload="SaveState();" onLoad="RestoreState();">' );
  Htm.Add( '' );
  Htm.Add( '<h1 align="center"><font face="Arial" color="#' + HdColor + '">' +
           TitleString + '</font></h1>' );

  if FileExists( SourcePath + 'Intro.bdy' ) then
  begin
    Tmp0 := NewStrList;
    Tmp0.LoadFromFile( SourcePath + 'Intro.bdy' );
    Htm.AddStrings( Tmp0 );
    Tmp0.Free;
  end;

  Htm.Add( '<hr>' );
  Htm.Add( '' );
  Htm.Add( '<table border="0" cellpadding="0" cellspacing="0" width="100%">' );
  Htm.Add( '  <tr>' );
  Htm.Add( '    <td valign="top" id="ByDependances"><h2 align="center">' );
  if UseWebdings then
    Htm.Add( '&nbsp;<font face="Wingdings" size=7 onclick="ShowByNames();">&#222;</font>&nbsp;' )
  else
    Htm.Add( '<img src="ABC.gif" alt="Sort by names" align=left onclick="ShowByNames();">' );
  Htm.Add( '<font color="#' + HdColor + '" face="Arial">Units</font></h2>' );
  Htm.Add( '    <ul compact>' );

  for I := 0 to L.Count - 1 do
  begin
    UnitTopic := UnitsList.Items[ I ];
    UnitTopic.FHandled := False;
    for J := 0 to UnitTopic.TopicsCount - 1 do
    begin
      Topic := UnitTopic.Topics[ J ];
      Topic.FHandled := False;
    end;
  end;

  PrevUnitTopic := nil;
  for I := 0 to L.Count - 1 do
  begin
    FoundTopic := nil; M := L.Count;
    for J := 0 to L.Count - 1 do
    begin
      UnitTopic := L.Items[ J ];
      if UnitTopic.FHandled then continue;
      N := 0;
      for K := 0 to UnitTopic.FUses.Count - 1 do
      begin
        Topic := UnitTopicByName( UnitTopic.Fuses.Items[ K ] );
        if Topic = nil then continue;
        if Topic.FHandled then continue;
        Inc( N );
      end;
      if (FoundTopic = nil) or (N < M) then
      begin
        FoundTopic := UnitTopic;
        M := N;
      end;
    end;
    if FoundTopic = nil then break;
    FoundTopic.FHandled := True;
    if PrevUnitTopic <> nil then
    begin
      PrevUnitTopic.FNext := FoundTopic;
      FoundTopic.FPrev := PrevUnitTopic;
    end;
    PrevUnitTopic := FoundTopic;
    Htm.Add( '        <li><a href=' + FoundTopic.HtName + '>' + FoundTopic.Name + '.pas</a></li>' );
  end;

  Htm.Add( '    </ul>' );
  Htm.Add( '    </td>' );
  Htm.Add( '    <td valign="top" id="ByNames" style="display:none"><h2 align="center">' );

  if UseWebdings then
    Htm.Add( '&nbsp;<font face="Wingdings" size=7 onclick="ShowByDependances();">&#222;</font>&nbsp;' )
  else
    Htm.Add( '<img src="ABC.gif" alt="Sort by names" align=left onclick="ShowByDependances();">' );
  Htm.Add( '<font color="#' + HdColor + '" face="Arial">Units</font></h2>' );
  Htm.Add( '    <ul compact>' );

  SortData( L, L.Count, @CompareTopics, @SwapTopics );

  for I := 0 to UnitsList.Count - 1 do
  begin
    UnitTopic := UnitsList.Items[ I ];
    Htm.Add( '        <li><a href=' + UnitTopic.HtName + '>' + UnitTopic.Name + '.pas</a></li>' );
  end;

  Htm.Add( '    </ul>' );
  Htm.Add( '    </td>' );

  Htm.Add( '    <td valign="top" id="ClassTree">' );
  Htm.Add( '      <table border=0><tr>' );
  Htm.Add( '      <td valign=top width=40>' );
  if UseWebdings then
    Htm.Add( '&nbsp;<font face="Wingdings" size=7 onclick="ExpandCollapseAll();">&#49;</font>&nbsp;' )
  else
    Htm.Add( '<img src="PLUS.gif" align=left alt="Expand/collapse all" onclick="ExpandCollapseAll();">' );
  Htm.Add( '</td>' );
  Htm.Add( '      <td valign=top><h2 align="center"><font face="Arial" color="#' + HdColor + '">Classes and Objects</font></h2></td>' );
  Htm.Add( '      <td valign=top>' );
  if UseWebdings then
    Htm.Add( '&nbsp;<font face="Wingdings" size=7 onclick="SortClasses();">&#202;</font>&nbsp;' )
  else
    Htm.Add( '<img src="ABC.gif" align=left alt="Sort by name" onclick="SortClasses();">' );
  Htm.Add( '</td>' );
  Htm.Add( '      </tr></table>' );

  AddClassTreeToHtm( Htm, Tree );

  Htm.Add( '    </td>' );

  Htm.Add( '    <td valign="top" id="ClassesByName" style="display:none">' );
  Htm.Add( '      <table border=0><tr>' );
  Htm.Add( '      <td valign=top width=40>&nbsp;</td>' );
  Htm.Add( '      <td valign=top><h2 align="center"><font face="Arial" color="#' + HdColor + '">Classes and Objects</font></h2></td>' );
  Htm.Add( '      <td valign=top>' );
  if UseWebdings then
    Htm.Add( '&nbsp;<font face="Terminal" size=7 onclick="ShowClassTree();">&#213;&#202;&#184;</font>&nbsp;' )
  else
    Htm.Add( '<img src="TREE.gif" align=left alt="Show tree" onclick="ShowClassTree();">' );
  Htm.Add( '</td>' );
  Htm.Add( '      </tr></table>' );
  Htm.Add( '      <ul>' );

  ClassList := NewList;
  for I := 0 to UnitsList.Count - 1 do
  begin
    UnitTopic := UnitsList.Items[ I ];
    for J := 0 to UnitTopic.TopicsCount - 1 do
    begin
      //if UnitTopic.Topics[ J ] then
      //begin
        Topic := UnitTopic.Topics[ J ];
        if Topic.TopicType = ttClass then
          ClassList.Add( Topic );
      //end;
    end;
  end;

  SortData( ClassList, ClassList.Count, @CompareTopics, @SwapTopics );

  for I := 0 to ClassList.Count - 1 do
  begin
    ClassTopic := ClassList.Items[ I ];
    Htm.Add( '          <li><a href=' + ClassTopic.HtName + '>' + ClassTopic.Name + '</a></li>' );
  end;

  ClassList.Free;

  Tree.Free;

  Htm.Add( '      </ul>' );

  Htm.Add( '    </td>' );
  Htm.Add( '  </tr>' );
  Htm.Add( '</table>' );
  Htm.Add( '<hr>' );

  // Add glossary to index:
  Label1.Caption := 'Building glossary';
  DoProcessMessages;

  Htm.Add( '<a name="Glossary"></a><h2 align="center"><font color="#' + HdColor + '" face="Arial">Glossary</font></h2>' );
  S := '<p align=center><font face="Arial"><b>';
  for C := 'A' to 'Z' do
  begin
    G := nil;
    for I := 0 to Glossary.Count - 1 do
    begin
      G1 := Glossary.Items[ I ];
      if UpperCase( G1.Name + ' ' )[ 1 ] = C then
      begin
        G := G1;
        break;
      end;
    end;
    if G = nil then
       S := S + '[&nbsp;' + C + '&nbsp;] '
    else
    begin
      Htm.Add( S );
      S := '[&nbsp;<a href=#glossary_' + C + '>' + C + '</a>&nbsp;] ';
    end;
    if C = 'M' then S := S + '<br>';
  end;
  Htm.Add( S + '</b></font></p>' );
  Htm.Add( '<p>' );
  I := 0; C := ' ';
  while I < Glossary.Count do
  begin
    G := Glossary.Items[ I ];
    if C <> UpperCase( G.Name + 'A' )[ 1 ] then
    begin
      C := UpperCase( G.Name + 'A' )[ 1 ];
      if C > 'A' then
         Htm.Add( '<br>' );
      Htm.Add( '<a name=glossary_' + C + '></a>' );
    end;
    S := '<a href="';
    if G.InClass <> nil then
    begin
       S := S + G.InClass.HtName;
       if G.Name <> G.InClass.Name then
          S := S + '#' + LowerCase( G.Name );
    end
       else
    if G.InUnit <> nil then
    begin
       S := S + G.InUnit.HtName;
       if G.Name <> G.InUnit.Name then
          S := S + '#' + LowerCase( G.Name );
    end
       else
       S := '';
    if S <> '' then
    begin
      S1 := G.Name;
      if (G.InUnit <> nil) and //StrEq( G.Name, G.InUnit.Name ) then
                               (G.Name = G.InUnit.Name) then
         S1 := S1 + '.pas'

      else
       if G.InClass <> nil then
       if G.InClass.Name = G.Name then
       begin
          S1 := S1 + ' ';
          if pos( 'class', LowerCase( G.InClass.Definition ) ) > 0 then
             S1 := S1 + 'class'
          else
          if pos( 'object', LowerCase( G.InClass.Definition ) ) > 0 then
             S1 := S1 + 'object'
          else
          if pos( 'interface', LowerCase( G.InClass.Definition ) ) > 0 then
             S1 := S1 + 'interface'
          else
             S1 := S1 + 'type';
       end;

      S := S + '"><b>' + S1 + '</b></a>';
      if (G.InClass <> nil) and //not StrEq( G.Name, G.InClass.Name ) then
                                (G.Name <> G.InClass.Name) then
         S := S + '; <a href="' + G.InClass.HtName + '">' + G.InClass.Name + '</a>.' +
              G.Name;
      if (G.InUnit <> nil) and //not StrEq( G.Name, G.InUnit.Name ) then
                               (G.Name <> G.InUnit.Name) then
         S := S + ' (<a href="' + G.InUnit.HtName + '">' + G.InUnit.Name + '.pas</a> )';
      S := S + '<br>';
      Htm.Add( S );
    end;
    Inc( I );
  end;
  Htm.Add( '</p>' );
  Htm.Add( '<hr>' );
  Htm.Add( '<p align="center">[&nbsp;<a href="http://xcl.cjb.net">KOL&nbsp;Home</a>&nbsp;]</p>' );
  Htm.Add( '<p align="center"><font face="Comic Sans MS"><small>This help is generated ' +
           Int2Str( FTime.wDay ) + '-' + Months[ FTime.wMonth ] + '-' +
           Int2Str( FTime.wYear ) + cVK_BAP);

  Htm.Add( '</body>' );
  Htm.Add( '</html>' );
  SaveHtm( Htm, ResultPath + 'index.htm' );
  Htm.Free;

    Ini := OpenIniFile( IniDirPath + 'XHelpGen.ini' );
    Ini.Mode := ifmWrite;
    Ini.Section := 'Source';
    Ini.ClearSection;
    Ini.ValueString( 'SourcePath', SourcePath );
    Ini.ValueString( 'ResultPath', ResultPath );
    Ini.ValueBoolean( 'UseJavaScript', UseJavaScript );
    K := 0;
    for I := 0 to FileList.Count - 1 do
    begin
      F := CreateFile( PChar( SourcePath + UnitPath( I ) ), GENERIC_READ,
           FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0 );
      if F > 0 then
      begin
        Inc( K );
        GetFileTime( F, nil, nil, @FileTime );
        FileTimeToSystemTime( FileTime, SysTime );
        S := UnitPath( I ) + ',' + T2Str( SysTime );
        Ini.ValueString( 'File' + Int2Str( K ), S );
        CloseHandle( F );
      end;
    end;
    Ini.ValueInteger( 'FileCount', K );
    {
    for I := 0 to UnitsList.Count - 1 do
    begin
      UnitTopic := UnitsList[ I ];
      S := '';
      for J := 0 to UnitsList.Count - 1 do
        if Copy( UnitTopic.FUnitRefs, J + 1, 1 ) = '1' then
        begin
          Topic := UnitsTopic[ J ];
          if S <> '' then S := S + ',';
          S := S + Topic.Name;
        end;
      if S <> '' then
         Ini.ValueString( 'Refs_' + LowerCase( UnitTopic.Name ), S, S );
      S := '';
      for J := 0 to UnitTopic.FClassRefs - 1 do
      begin
        if S <> '' then S := S = ',';
        S := S + UnitTopic.FClassRefs[ J ];
      end;
      if S <> '' then
         Ini.ValueString( 'Undef_' + LowerCase( UnitTopic.Name ), S, S );
    end;
    }
    S := ExePath;
    {
    S := GetCommandLine;
    if S[ 1 ] = '"' then
    begin
      S[ 1 ] := ' ';
      I := IndexOfChar( S, '"' );
    end
       else I := IndexOfChar( S, ' ' );
    if I > 1 then S := Copy( S, 1, I - 1 );
    S := Trim( S );
    }
    F := CreateFile( PChar( S ), GENERIC_READ,
         FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0 );
    if F > 0 then
    begin
      GetFileTime( F, nil, nil, @FileTime );
      FileTimeToSystemTime( FileTime, SysTime );
      S := T2Str( SysTime );
      Ini.ValueString( 'HelpGenVersion', S );
      CloseHandle( F );
    end;

    Ini.Free;
  END;

  for I := L.Count - 1 downto 0 do
  begin
    PObj( L.Items[ I ] ).Free;
  end;
  L.Free;

  for I := Glossary.Count - 1 downto 0 do
      PObj( Glossary.Items[ I ] ).Free;
  Glossary.Free;

  for I := CustomRefs.Count - 1 downto 0 do
      PObj( CustomRefs.Items[ I ] ).Free;
  CustomRefs.Free;

  PostQuitMessage( 0 );
end;

procedure TEventObj.CancelBuild(Sender: PObj);
begin
  Cancel := True;
end;

destructor TEventObj.Destroy;
begin
  FTimer.Free;
  inherited;
end;

procedure TEventObj.TimerTick(Sender: PObj);
begin
  if (FileList <> nil) and (FileList.Count > 0) then
  begin
    FTimer.Enabled := False;
    //Button1.Down := True;
    Button1.Perform( WM_LBUTTONDOWN, 0, 0 );
    Button1.Perform( WM_LBUTTONUP, 0, 0 );
  end;
end;

{
procedure TForm1.WNNCHitTest(var Msg: TWMNCHitTest);
var P : TPoint;
begin
  inherited;
  P.x := Msg.XPos;
  P.y := Msg.YPos;
  P := ScreenToClient( P );
  if not PointInRect( P, Button.ControlRect ) then
     Msg.Result := HTCAPTION;
end;
}

{ XTopic }

function NewTopic(AParent : PTopic; TopicType: TTopicType; const TopicName,
  Definition: String; Description: PStrList): PTopic;
var I, J: Integer;
    S: String;
    G: PGlossElt;
begin
  New( Result, Create );
  Result.FType := TopicType;
  Result.FName := TopicName;
  Result.FDefinition := Definition;
  Result.FDescription := Description;
  Result.FTasks := NewStrList;
  Result.FMacroList := NewStrList;
  Result.FTopics := NewList;
  if AParent <> nil then
  begin
    Result.FParentTopic := AParent;
    if AParent.FTopics = nil then
      AParent.FTopics := NewList;
    AParent.FTopics.Add( Result );
  end;
  if Description <> nil then
  begin
    for I := 0 to Description.Count - 1 do
    begin
      S := Trim( Description.Items[ I ] );
      if Copy( S, 1, 3 ) = '|<#' then
      begin
        S := CopyEnd( S, 4 );
        J := pos( '>', S );
        if J > 0 then
        begin
          Description.Items[ I ] := '| <a name="' + Copy( S, 1, J - 1 ) + '">';
          G := NewGlossElt;
          CustomRefs.Add( G );
          G.Name := Copy( S, 1, J - 1 );
          S := Trim( CopyEnd( S, J + 1 ) );
          G.Text := S;
          if G.Text = '' then
            G.Text := Definition;
          G.RefTopic := Result;
          case TopicType of
          ttUnit: begin
                    G.InUnit := Result;
                  end;
          ttClass:begin
                    G.InClass := Result;
                  end;
          else G.InClass := AParent;
          end;
        end;
      end;
    end;
  end;
end;

destructor TTopic.Destroy;
begin
  FName := '';
  FDefinition := '';
  FAncestor := '';
  FDescription.Free;
  FDescrText.Free;
  FUses.Free;
  FTasks.Free;
  FRecDef.Free;
  FRecCln.Free;
  FMacroList.Free;
  inherited;
end;

function TTopic.GetChanged: Boolean;
begin
  Result := True;
end;
{
var I : Integer;
    Topic : XTopic;
begin
  Result := FIsChanged;
  if not Result then
  if FPrev <> nil then
  if FPrev.FIsChanged then
     Result := True;
  if not Result then
  if FNext <> nil then
  if FNext.FIsChanged then
     Result := True;
  if not Result then
  for I := 0 to FUses.Count - 1 do
  begin
    Topic := UnitTopicByName( FUses[ I ] );
    if Topic = nil then continue;
    if Topic.FIsChanged then Result := True;
    if Result then break;
  end;
end;
}

function TTopic.GetChildTopic(Idx: Integer): PTopic;
begin
  Result := FTopics.Items[ Idx ];
end;

function TTopic.GetChildTopicCount: Integer;
begin
  Result := 0;
  if FTopics = nil then Exit;
  Result := FTopics.Count;
end;

function TTopic.GetHtName: String;
begin
  Result := Name + '.htm';
  if ParentTopic = nil then Result := Name + '_pas.htm'
  else
  if TopicType <> ttClass then
     Result := ParentTopic.HtName + '#' + Name;
  Result := LowerCase( Result );
end;

function TTopic.GetReadOnly: TTriplean;
var A : PTopic;
begin
  Result := FReadOnly;
  if Result = Unknown then
  begin
    if Ancestor <> '' then
    begin
      A := ClassTopicByName( Ancestor );
      Result := A.IsReadOnly;
    end;
  end;
end;

{ TGlossElt }

destructor TGlossElt.Destroy;
begin
  Name := '';
  Text := '';
end;

initialization

finalization
  FileList.Free;

end.